﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RosenBrockFunction
{
    class Simplex
    {          
        string whichIsBest;
        public string WhichIsBest
        {
            get { return whichIsBest; }
            set { whichIsBest = value; }
        }
      
        Vertix[] vArr = new Vertix[5]
        {
                new Vertix(1, 1, 1,  0),    //(-1.2, 1,  0),
                new Vertix(1.05, 1.05, 1.05,  0),  //(-1.1, 1,  0),    this.vArr[4].Cost = 0; this.vArr[4].A = -1.1; this.vArr[4].B = 1;
                new Vertix(1.1, 1.1, 1.1,   0),    //(-1.2,  1.1,  0),       
                new Vertix(1, 1, 1,   0),    //(-1.2, 1,   0),
                new Vertix(1, 1, 1,   0),    //(-1.2, 1,   0),          
        };
        public Vertix[] VArr
        {
            get { return vArr; }
            set { vArr = value; }
        }
        Vertix[] vArr1 = new Vertix[5]
        {
                new Vertix(1, 1, 1,  0),    //(-1.2, 1,  0),
                new Vertix(0.95, 1, 0.95,  0),  //(-1.1, 1,  0),    this.vArr[4].Cost = 0; this.vArr[4].A = -1.1; this.vArr[4].B = 1;
                new Vertix(0.95, 1.05, 0.95,   0),    //(-1.2,  1.1,  0),       
                new Vertix(0.9, 1.05, 0.9,   0),    //(-1.2, 1,   0),
                new Vertix(0.9, 1.1, 0.9,   0),    //(-1.2, 1,   0),          
        };
        public Vertix[] VArr1
        {
            get { return vArr1; }
            set { vArr1 = value; }
        }
        Vertix[] vArr3 = new Vertix[5]
        {
                new Vertix(1, 1, 1,  0),    //(-1.2, 1,  0),
                new Vertix(1, 0.95, 1,  0),  //(-1.1, 1,  0),    this.vArr[4].Cost = 0; this.vArr[4].A = -1.1; this.vArr[4].B = 1;
                new Vertix(1.05, 0.95, 1.05,   0),    //(-1.2,  1.1,  0),       
                new Vertix(1.05, 0.9, 1.05,   0),    //(-1.2, 1,   0),
                new Vertix(1.1, 0.9, 1.1,   0),    //(-1.2, 1,   0),          
        };
        public Vertix[] VArr3
        {
            get { return vArr3; }
            set { vArr3 = value; }
        }

        Vertix[] vArr4 = new Vertix[5]
        {
                new Vertix(1, 1, 1,  0),    //(-1.2, 1,  0),
                new Vertix(0.95, 0.95, 0.95,  0),  //(-1.1, 1,  0),    this.vArr[4].Cost = 0; this.vArr[4].A = -1.1; this.vArr[4].B = 1;
                new Vertix(0.9, 0.9, 0.9,   0),    //(-1.2,  1.1,  0),       
                new Vertix(0.85, 0.85, 0.85,   0),    //(-1.2, 1,   0),
                new Vertix(0.8, 0.8, 0.8,   0),    //(-1.2, 1,   0),          
        };
        public Vertix[] VArr4
        {
            get { return vArr4; }
            set { vArr4 = value; }
        }
        double hassan;
        public double Hassan
        {
            get { return hassan; }
        }
        double[] z = new double[5] { 0, 0, 0, 0, 0 };
        string[] optimizeElementsInVertix = new string[3]
        {
            "It did not optimize yet", "It did not optimize yet", "It did not optimize yet"
        };
        public double[] numOfOperations = new double[6]
        {
            0, 0, 0, 0, 0, 0
        };
        public string[] OptimizeElementsInVertix
        {
            get { return optimizeElementsInVertix; }
            set { optimizeElementsInVertix = value; }
        }
        public Simplex() {}                     
        
        public void ComputeCost( int i) //i=which cost
        {

            this.vArr[i].Cost = Math.Pow(0.14 - (this.vArr[i].A + 1/ ( 15 * this.vArr[i].B + this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.18 - (this.vArr[i].A + 2 / (14 * this.vArr[i].B + 2 *this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.22 - (this.vArr[i].A + 3 / (13 * this.vArr[i].B + 3 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.25 - (this.vArr[i].A + 4 / (12 * this.vArr[i].B + 4 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.29 - (this.vArr[i].A + 5 / (11 * this.vArr[i].B + 5 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.32 - (this.vArr[i].A + 6 / (10 * this.vArr[i].B + 6 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.35 - (this.vArr[i].A + 7 / (9 * this.vArr[i].B + 7 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.39 - (this.vArr[i].A + 8 / (8 * this.vArr[i].B + 8 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.37 - (this.vArr[i].A + 9 / (7 * this.vArr[i].B + 7 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.58 - (this.vArr[i].A + 10 / (6 * this.vArr[i].B + 6 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.73 - (this.vArr[i].A + 11 / (5 * this.vArr[i].B + 5 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(0.96 - (this.vArr[i].A + 12 / (4 * this.vArr[i].B + 4 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(1.34 - (this.vArr[i].A + 13 / (3 * this.vArr[i].B + 3 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(2.1 - (this.vArr[i].A + 14 / (2 * this.vArr[i].B + 2 * this.vArr[i].C)), 2);
            this.vArr[i].Cost += Math.Pow(4.39 - (this.vArr[i].A + 15 / (this.vArr[i].B + this.vArr[i].C)), 2);
            z[0] += 1;
        }
        public void ComputeCost1(int i) //i=which cost
        {

            this.vArr1[i].Cost = Math.Pow(0.14 - (this.vArr1[i].A + 1 / (15 * this.vArr1[i].B + this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.18 - (this.vArr1[i].A + 2 / (14 * this.vArr1[i].B + 2 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.22 - (this.vArr1[i].A + 3 / (13 * this.vArr1[i].B + 3 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.25 - (this.vArr1[i].A + 4 / (12 * this.vArr1[i].B + 4 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.29 - (this.vArr1[i].A + 5 / (11 * this.vArr1[i].B + 5 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.32 - (this.vArr1[i].A + 6 / (10 * this.vArr1[i].B + 6 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.35 - (this.vArr1[i].A + 7 / (9 * this.vArr1[i].B + 7 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.39 - (this.vArr1[i].A + 8 / (8 * this.vArr1[i].B + 8 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.37 - (this.vArr1[i].A + 9 / (7 * this.vArr1[i].B + 7 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.58 - (this.vArr1[i].A + 10 / (6 * this.vArr1[i].B + 6 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.73 - (this.vArr1[i].A + 11 / (5 * this.vArr1[i].B + 5 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(0.96 - (this.vArr1[i].A + 12 / (4 * this.vArr1[i].B + 4 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(1.34 - (this.vArr1[i].A + 13 / (3 * this.vArr1[i].B + 3 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(2.1 - (this.vArr1[i].A + 14 / (2 * this.vArr1[i].B + 2 * this.vArr1[i].C)), 2);
            this.vArr1[i].Cost += Math.Pow(4.39 - (this.vArr1[i].A + 15 / (this.vArr1[i].B + this.vArr1[i].C)), 2);
            z[1] += 1;
        }
        public void ComputeCost3(int i) //i=which cost
        {

            this.vArr3[i].Cost = Math.Pow(0.14 - (this.vArr3[i].A + 1 / (15 * this.vArr3[i].B + this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.18 - (this.vArr3[i].A + 2 / (14 * this.vArr3[i].B + 2 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.22 - (this.vArr3[i].A + 3 / (13 * this.vArr3[i].B + 3 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.25 - (this.vArr3[i].A + 4 / (12 * this.vArr3[i].B + 4 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.29 - (this.vArr3[i].A + 5 / (11 * this.vArr3[i].B + 5 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.32 - (this.vArr3[i].A + 6 / (10 * this.vArr3[i].B + 6 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.35 - (this.vArr3[i].A + 7 / (9 * this.vArr3[i].B + 7 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.39 - (this.vArr3[i].A + 8 / (8 * this.vArr3[i].B + 8 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.37 - (this.vArr3[i].A + 9 / (7 * this.vArr3[i].B + 7 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.58 - (this.vArr3[i].A + 10 / (6 * this.vArr3[i].B + 6 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.73 - (this.vArr3[i].A + 11 / (5 * this.vArr3[i].B + 5 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(0.96 - (this.vArr3[i].A + 12 / (4 * this.vArr3[i].B + 4 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(1.34 - (this.vArr3[i].A + 13 / (3 * this.vArr3[i].B + 3 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(2.1 - (this.vArr3[i].A + 14 / (2 * this.vArr3[i].B + 2 * this.vArr3[i].C)), 2);
            this.vArr3[i].Cost += Math.Pow(4.39 - (this.vArr3[i].A + 15 / (this.vArr3[i].B + this.vArr3[i].C)), 2);
            z[3] += 1;
        }
        public void ComputeCost4(int i) //i=which cost
        {

            this.vArr4[i].Cost = Math.Pow(0.14 - (this.vArr4[i].A + 1 / (15 * this.vArr4[i].B + this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.18 - (this.vArr4[i].A + 2 / (14 * this.vArr4[i].B + 2 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.22 - (this.vArr4[i].A + 3 / (13 * this.vArr4[i].B + 3 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.25 - (this.vArr4[i].A + 4 / (12 * this.vArr4[i].B + 4 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.29 - (this.vArr4[i].A + 5 / (11 * this.vArr4[i].B + 5 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.32 - (this.vArr4[i].A + 6 / (10 * this.vArr4[i].B + 6 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.35 - (this.vArr4[i].A + 7 / (9 * this.vArr4[i].B + 7 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.39 - (this.vArr4[i].A + 8 / (8 * this.vArr4[i].B + 8 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.37 - (this.vArr4[i].A + 9 / (7 * this.vArr4[i].B + 7 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.58 - (this.vArr4[i].A + 10 / (6 * this.vArr4[i].B + 6 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.73 - (this.vArr4[i].A + 11 / (5 * this.vArr4[i].B + 5 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(0.96 - (this.vArr4[i].A + 12 / (4 * this.vArr4[i].B + 4 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(1.34 - (this.vArr4[i].A + 13 / (3 * this.vArr4[i].B + 3 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(2.1 - (this.vArr4[i].A + 14 / (2 * this.vArr4[i].B + 2 * this.vArr4[i].C)), 2);
            this.vArr4[i].Cost += Math.Pow(4.39 - (this.vArr4[i].A + 15 / (this.vArr4[i].B + this.vArr4[i].C)), 2);
            z[4] += 1;
        } 
       

        public bool DoOptimizationOnVertixElements( int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr[3].Cost;
            this.vArr[4] = (Vertix)this.vArr[3].Clone(); // copy in case we cannot improve
            this.vArr[3] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost(3);

            if (this.vArr[3].Cost < costTest) /// Try Expansion
            {
                this.vArr[4] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                ComputeCost(4);// find cost0

                if (this.vArr[4].Cost < this.vArr[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
            }

            if (this.vArr[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                 this.vArr[3] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                 ComputeCost(3);  // contract to c1

                 if (costTest <= this.vArr[3].Cost)   // Check c1
                 {
                     this.vArr[3] = (Vertix)this.vArr[4].Clone();
                     this.vArr[3] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                     ComputeCost(3);// find cost
                    
                     if  (this.vArr[3].Cost < costTest)  // c2 is better than c1
                     {
                         optimize = true;
                         optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                         numOfOperations[2] += 1;
                     }
                     else
                     {                         
                             this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                             optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";                          
                     }

                 }
                 else
                 {
                     optimize = true;  // C1 is better
                     optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                     numOfOperations[3] += 1;
                 }
            }

            if (this.vArr[3].Cost >= costTest)
            {
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                this.VArr[3] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[3], whichParameterOfVertix);
                ComputeCost(3);
                if (costTest <= this.vArr[3].Cost)    // Contract W to B
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr[3] = Vertix.ShrinkWToB(this.vArr[0], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                    ComputeCost(3);
                    if (this.vArr[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }
            
            this.vArr[4].Cost = 0; this.vArr[4].A = 1.05; this.vArr[4].B = 1.05; this.vArr[4].C = 1.05; //this.vArr[4].TY = 0; this.vArr[4].TX = 0;
            ComputeCost(4);            
            return optimize;
        }

        public bool DoOptimizationOnVertixElements1(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr1[3].Cost;
            this.vArr1[4] = (Vertix)this.vArr1[3].Clone(); // copy in case we cannot improve
            this.vArr1[3] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost1(3);

            if (this.vArr1[3].Cost < costTest) /// Try Expansion
            {
                this.vArr1[4] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(4);// find cost0

                if (this.vArr1[4].Cost < this.vArr1[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
            }

            if (this.vArr1[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                this.vArr1[3] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(3);  // contract to c1

                if (costTest <= this.vArr1[3].Cost)   // Check c1
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    this.vArr1[3] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                    ComputeCost1(3);// find cost

                    if (this.vArr1[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 1;
                    }
                    else
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 1;
                }
            }

            if (this.vArr1[3].Cost >= costTest)
            {
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                this.vArr1[3] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(3);
                if (costTest <= this.vArr1[3].Cost)    // Contract W to B
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    this.vArr1[3] = Vertix.ShrinkWToB(this.vArr1[0], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                    ComputeCost1(3);
                    if (this.vArr1[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }


            this.vArr1[4].Cost = 0; this.vArr1[4].A = 0.95; this.vArr1[4].B = 1.05; this.vArr1[4].C = 0.95; 
            ComputeCost1(4);
            return optimize;
        }

        public bool DoOptimizationOnVertixElements3(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr3[3].Cost;
            this.vArr3[4] = (Vertix)this.vArr3[3].Clone(); // copy in case we cannot improve
            this.vArr3[3] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost3(3);

            if (this.vArr3[3].Cost < costTest) /// Try Expansion
            {
                this.vArr3[4] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(4);// find cost0

                if (this.vArr3[4].Cost < this.vArr3[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
            }

            if (this.vArr3[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                this.vArr3[3] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(3);  // contract to c1

                if (costTest <= this.vArr3[3].Cost)   // Check c1
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    this.vArr3[3] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                    ComputeCost3(3);// find cost

                    if (this.vArr3[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 1;
                    }
                    else
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 1;
                }
            }

            if (this.vArr3[3].Cost >= costTest)
            {
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                this.vArr3[3] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(3);
                if (costTest <= this.vArr3[3].Cost)    // Contract W to B
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    this.vArr3[3] = Vertix.ShrinkWToB(this.vArr3[0], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                    ComputeCost3(3);
                    if (this.vArr3[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }

            this.vArr3[4].Cost = 0; this.vArr3[4].A = 1; this.vArr3[4].B = 1; this.vArr3[4].C = 1;
            ComputeCost3(4);
            return optimize;
        }
        public bool DoOptimizationOnVertixElements4(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr4[3].Cost;
            this.vArr4[4] = (Vertix)this.vArr4[3].Clone(); // copy in case we cannot improve
            this.vArr4[3] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost4(3);

            if (this.vArr4[3].Cost < costTest) /// Try Expansion
            {
                this.vArr4[4] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(4);// find cost0

                if (this.vArr4[4].Cost < this.vArr4[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
            }

            if (this.vArr4[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                this.vArr4[3] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(3);  // contract to c1

                if (costTest <= this.vArr4[3].Cost)   // Check c1
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    this.vArr4[3] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                    ComputeCost4(3);// find cost

                    if (this.vArr4[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 1;
                    }
                    else
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 1;
                }
            }

            if (this.vArr4[3].Cost >= costTest)
            {
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                this.VArr4[3] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(3);
                if (costTest <= this.vArr4[3].Cost)    // Contract W to B
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    this.VArr4[3] = Vertix.ShrinkWToB(this.vArr4[0], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                    ComputeCost4(3);
                    if (this.vArr4[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }


            this.vArr4[4].Cost = 0; this.vArr4[4].A = 1; this.vArr4[4].B = 1; this.vArr4[4].C = 1; 
            ComputeCost4(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck()
        {
            bool optimize = false;
            double costTest = this.vArr[3].Cost;


            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0); // 1. try reflection
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
            ComputeCost(4);
            if (this.vArr[4].Cost < costTest) /// Try Expansion
            {
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 0);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 1);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 2);
                ComputeCost(3);// find cost0

                if (this.vArr[3].Cost < this.vArr[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; numOfOperations[1] += 3;
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; numOfOperations[0] += 3;
                }

            }

            if (this.vArr[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
                ComputeCost(4);  // contract to c1

                if (costTest <= this.vArr[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
                    ComputeCost(4);// find cost

                    if (this.vArr[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; numOfOperations[2] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; numOfOperations[3] += 3;
                }
            }

            if (this.vArr[3].Cost >= costTest)
            {
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 0);
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 1);
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 2);
                ComputeCost(4);
                if (costTest <= this.vArr[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 0);
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 1);
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 2);
                    ComputeCost(4);
                    if (this.vArr[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; numOfOperations[5] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; numOfOperations[4] += 3;
                }
            }
            this.vArr[4].Cost = 0; this.vArr[4].A = 1.05; this.vArr[4].B = 1.05; this.vArr[4].C = 1.05; //this.vArr[4].TY = 0; this.vArr[4].TX = 0;
            ComputeCost(4);
            return optimize;
        }

        public bool DoOptimizationWheenThStuck1()
        {
            bool optimize = false;
            double costTest = this.vArr1[3].Cost;


            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0); // 1. try reflection
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
            ComputeCost1(4);
            if (this.vArr1[4].Cost < costTest) /// Try Expansion
            {
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 0);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 1);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 2);
                ComputeCost1(3);// find cost0

                if (this.vArr1[3].Cost < this.vArr1[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; numOfOperations[1] += 3;
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; numOfOperations[0] += 3;
                }

            }

            if (this.vArr1[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
                ComputeCost1(4);  // contract to c1

                if (costTest <= this.vArr1[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
                    ComputeCost1(4);// find cost

                    if (this.vArr1[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; numOfOperations[2] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; numOfOperations[3] += 3;
                }
            }

            if (this.vArr1[3].Cost >= costTest)
            {
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 0);
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 1);
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 2);
                ComputeCost1(4);
                if (costTest <= this.vArr1[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 0);
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 1);
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 2);
                    ComputeCost1(4);
                    if (this.vArr1[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; numOfOperations[5] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; numOfOperations[4] += 3;
                }
            }

            this.vArr1[4].Cost = 0; this.vArr1[4].A = 0.95; this.vArr1[4].B = 1.05; this.vArr1[4].C = 0.95; 
            ComputeCost1(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck3()
        {
            bool optimize = false;
            double costTest = this.vArr3[3].Cost;


            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0); // 1. try reflection
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
            ComputeCost3(4);
            if (this.vArr3[4].Cost < costTest) /// Try Expansion
            {
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 0);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 1);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 2);
                ComputeCost3(3);// find cost0

                if (this.vArr3[3].Cost < this.vArr3[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; numOfOperations[1] += 3;
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; numOfOperations[0] += 3;
                }

            }

            if (this.vArr3[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
                ComputeCost3(4);  // contract to c1

                if (costTest <= this.vArr3[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
                    ComputeCost3(4);// find cost

                    if (this.vArr3[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; numOfOperations[2] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; numOfOperations[3] += 3;
                }
            }

            if (this.vArr3[3].Cost >= costTest)
            {
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 0);
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 1);
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 2);
                ComputeCost3(4);
                if (costTest <= this.vArr3[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 0);
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 1);
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 2);
                    ComputeCost3(4);
                    if (this.vArr3[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; numOfOperations[5] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; numOfOperations[4] += 3;
                }
            }
            this.vArr3[4].Cost = 0; this.vArr3[4].A = 1; this.vArr3[4].B = 1; this.vArr3[4].C = 1;
            ComputeCost3(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck4()
        {
            bool optimize = false;
            double costTest = this.vArr4[3].Cost;


            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0); // 1. try reflection
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
            ComputeCost4(4);
            if (this.vArr4[4].Cost < costTest) /// Try Expansion
            {
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 0);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 1);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 2);
                ComputeCost4(3);// find cost0

                if (this.vArr4[3].Cost < this.vArr4[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; numOfOperations[1] += 3;
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; numOfOperations[0] += 3;
                }

            }

            if (this.vArr4[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
                ComputeCost4(4);  // contract to c1

                if (costTest <= this.vArr4[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
                    ComputeCost4(4);// find cost

                    if (this.vArr4[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; numOfOperations[2] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; numOfOperations[3] += 3;
                }
            }

            if (this.vArr4[3].Cost >= costTest)
            {
                this.vArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 0);
                this.vArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 1);
                this.vArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 2);
                ComputeCost4(4);
                if (costTest <= this.vArr4[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 0);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 1);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 2);
                    ComputeCost4(4);
                    if (this.vArr4[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; numOfOperations[5] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; numOfOperations[4] += 3;
                }
            }

            this.vArr4[4].Cost = 0; this.vArr4[4].A = 1; this.vArr4[4].B = 1; this.vArr4[4].C = 1; 
            ComputeCost4(4);
            return optimize;
        }
        public object Clone(int i)
        {
            Simplex snew = (Simplex)this.MemberwiseClone();
            snew.vArr[i] = (Vertix)this.vArr[i].Clone();
            return snew;
        }

        public override string ToString()
        {
            return "NofIteration =" + this.z[0].ToString() + "\nA " + optimizeElementsInVertix[0] + "\nB " + optimizeElementsInVertix[1] + "\nC " + optimizeElementsInVertix[2] + "\nBest1: "
                + "a: " + this.vArr[0].A.ToString() + "\tb: " + this.vArr[0].B.ToString() + "\tCost1: " + this.vArr[0].Cost.ToString() + "\nBest2: " + "a: " +
                this.vArr1[0].A.ToString() + "\tb: " + this.vArr1[0].B.ToString() + "\tCost2: " + this.vArr1[0].Cost.ToString() + "\tNofIteration =" + this.z[1].ToString() + "\nBest4: "
                + "a: " + this.vArr3[0].A.ToString() + "\tb: " + this.vArr3[0].B.ToString() + "\tCost4: " + this.vArr3[0].Cost.ToString() + "\tNofIteration =" + this.z[3].ToString() +
                "\nBest5: " + "a: " + this.vArr4[0].A.ToString() + "\tb: " + this.vArr4[0].B.ToString() + "\tCost5: " + this.vArr4[0].Cost.ToString() + "\tNofIteration =" + 
                this.z[4].ToString();              

        }
    }
}