﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RosenBrockFunction
{
    class Simplex
    {          
        string whichIsBest;
        public string WhichIsBest
        {
            get { return whichIsBest; }
            set { whichIsBest = value; }
        }
      
        Vertix[] vArr = new Vertix[5]
        {
                new Vertix(0.4, 1, 0,  0),    //(-1.2, 1,  0),
                new Vertix(0.4 + 0.4 * 0.05, 1.05, 0.00025,  0),  //(-1.1, 1,  0),    this.vArr[4].Cost = 0; this.vArr[4].A = -1.1; this.vArr[4].B = 1;
                new Vertix(0.4 + 0.4 * 0.1, 1.1, 0.0005,   0),    //(-1.2,  1.1,  0),       
                new Vertix(0.4 + 0.4 * 0.1, 1.1, 0.0005,   0),    //(-1.2, 1,   0),
                new Vertix(0.4 + 0.4 * 0.1, 1.1, 0.0005,   0),    //(-1.2, 1,   0),          
        };
        public Vertix[] VArr
        {
            get { return vArr; }
            set { vArr = value; }
        }
        Vertix[] vArr1 = new Vertix[5]
        {
                new Vertix(0.4, 1, 0,  0),    //(-1.2, 1,  0),
                new Vertix(0.4 - 0.4 * 0.05 * 1, 1, -0.00025,  0),  //(-1.1, 1,  0),    this.vArr[4].Cost = 0; this.vArr[4].A = -1.1; this.vArr[4].B = 1;
                new Vertix(0.4 - 0.4 * 0.05 * 1, 1.05, -0.00025,   0),    //(-1.2,  1.1,  0),       
                new Vertix(0.4 - 0.4 * 0.05 * 2, 1.05, -0.0005,   0),    //(-1.2, 1,   0),
                new Vertix(0.4 - 0.4 * 0.05 * 2, 1.1, -0.0005,   0),    //(-1.2, 1,   0),          
        };
        public Vertix[] VArr1
        {
            get { return vArr1; }
            set { vArr1 = value; }
        }
        Vertix[] vArr2 = new Vertix[5]
        {
                new Vertix(0.4, 1, 0,  0),    //(-1.2, 1,  0),
                new Vertix(0.4, 0.95, 0,  0),  //(-1.1, 1,  0),    this.vArr[4].Cost = 0; this.vArr[4].A = -1.1; this.vArr[4].B = 1;
                new Vertix(0.4 + 0.4 * 0.05 * 1, 0.95, 0.00025,   0),    //(-1.2,  1.1,  0),       
                new Vertix(0.4 + 0.4 * 0.05 * 1, 0.90, 0.00025,   0),    //(-1.2, 1,   0),
                new Vertix(0.4 + 0.4 * 0.05 * 2, 0.90, 0.0005,   0),    //(-1.2, 1,   0),          
        };
        public Vertix[] VArr2
        {
            get { return vArr2; }
            set { vArr2 = value; }
        }

        Vertix[] vArr4 = new Vertix[5]
        {
                new Vertix(0.4, 1, 0,  0),    //(-1.2, 1,  0),
                new Vertix(0.4 - 0.4 * 0.05 * 1, 0.95, -0.00025,  0),  //(-1.1, 1,  0),    this.vArr[4].Cost = 0; this.vArr[4].A = -1.1; this.vArr[4].B = 1;
                new Vertix(0.4 - 0.4 * 0.05 * 2, 0.9, -0.0005,   0),    //(-1.2,  1.1,  0),       
                new Vertix(0.4 - 0.4 * 0.05 * 3, 0.85, -0.00075,   0),    //(-1.2, 1,   0),
                new Vertix(0.4 - 0.4 * 0.05 * 4, 0.80, -0.001,   0),    //(-1.2, 1,   0),          
        };
        public Vertix[] VArr4
        {
            get { return vArr4; }
            set { vArr4 = value; }
        }
        double hassan;
        public double Hassan
        {
            get { return hassan; }
        }
        double[] z = new double[5] { 0, 0, 0, 0, 0 };
        string[] optimizeElementsInVertix = new string[3]
        {
            "It did not optimize yet", "It did not optimize yet", "It did not optimize yet"
        };
        public double[] numOfOperations = new double[6]
        {
            0, 0, 0, 0, 0, 0
        };
        public string[] OptimizeElementsInVertix
        {
            get { return optimizeElementsInVertix; }
            set { optimizeElementsInVertix = value; }
        }
        public Simplex() {}                     
        
        public void ComputeCost( int i) //i=which cost
        {

            this.vArr[i].Cost = Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((7.0 / 2 - this.vArr[i].C), 2)) / 2.0) - 0.0009, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((3 - this.vArr[i].C), 2)) / 2.0) - 0.0044, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((5.0 / 2 - this.vArr[i].C), 2)) / 2.0) - 0.0175, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((2 - this.vArr[i].C), 2)) / 2.0) - 0.054, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((3.0 / 2 - this.vArr[i].C), 2)) / 2.0) - 0.1295, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((1 - this.vArr[i].C), 2)) / 2.0) - 0.242, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((1.0 / 2 - this.vArr[i].C), 2)) / 2.0) - 0.3521, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((- this.vArr[i].C), 2)) / 2.0) - 0.3989, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((-1.0 / 2 - this.vArr[i].C), 2)) / 2.0) - 0.3521, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((-1 - this.vArr[i].C), 2)) / 2.0) - 0.242, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((-3.0 / 2 - this.vArr[i].C), 2)) / 2.0) - 0.1295, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((-2 - this.vArr[i].C), 2)) / 2.0) - 0.054, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((-5.0 / 2 - this.vArr[i].C), 2)) / 2.0) - 0.0175, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((-3 - this.vArr[i].C), 2)) / 2.0) - 0.0044, 2);
            this.vArr[i].Cost += Math.Pow(this.vArr[i].A * Math.Exp((-this.vArr[i].B * Math.Pow((-7.0 / 2 - this.vArr[i].C), 2)) / 2.0) - 0.0009, 2);
            z[0] += 1;
            
        }

        public void ComputeCost1(int i) //i=which cost
        {

            this.vArr1[i].Cost = Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((7.0 / 2 - this.vArr1[i].C), 2)) / 2.0) - 0.0009, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((3 - this.vArr1[i].C), 2)) / 2.0) - 0.0044, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((5.0 / 2 - this.vArr1[i].C), 2)) / 2.0) - 0.0175, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((2 - this.vArr1[i].C), 2)) / 2.0) - 0.054, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((3.0 / 2 - this.vArr1[i].C), 2)) / 2.0) - 0.1295, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((1 - this.vArr1[i].C), 2)) / 2.0) - 0.242, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((1.0 / 2 - this.vArr1[i].C), 2)) / 2.0) - 0.3521, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((-this.vArr1[i].C), 2)) / 2.0) - 0.3989, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((-1.0 / 2 - this.vArr1[i].C), 2)) / 2.0) - 0.3521, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((-1 - this.vArr1[i].C), 2)) / 2.0) - 0.242, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((-3.0 / 2 - this.vArr1[i].C), 2)) / 2.0) - 0.1295, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((-2 - this.vArr1[i].C), 2)) / 2.0) - 0.054, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((-5.0 / 2 - this.vArr1[i].C), 2)) / 2.0) - 0.0175, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((-3 - this.vArr1[i].C), 2)) / 2.0) - 0.0044, 2);
            this.vArr1[i].Cost += Math.Pow(this.vArr1[i].A * Math.Exp((-this.vArr1[i].B * Math.Pow((-7.0 / 2 - this.vArr1[i].C), 2)) / 2.0) - 0.0009, 2);
            z[1] += 1;

        }
        public void ComputeCost2(int i) //i=which cost
        {

            this.vArr2[i].Cost = Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((7.0 / 2 - this.vArr2[i].C), 2)) / 2.0) - 0.0009, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((3 - this.vArr2[i].C), 2)) / 2.0) - 0.0044, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((5.0 / 2 - this.vArr2[i].C), 2)) / 2.0) - 0.0175, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((2 - this.vArr2[i].C), 2)) / 2.0) - 0.054, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((3.0 / 2 - this.vArr2[i].C), 2)) / 2.0) - 0.1295, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((1 - this.vArr2[i].C), 2)) / 2.0) - 0.242, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((1.0 / 2 - this.vArr2[i].C), 2)) / 2.0) - 0.3521, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((-this.vArr2[i].C), 2)) / 2.0) - 0.3989, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((-1.0 / 2 - this.vArr2[i].C), 2)) / 2.0) - 0.3521, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((-1 - this.vArr2[i].C), 2)) / 2.0) - 0.242, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((-3.0 / 2 - this.vArr2[i].C), 2)) / 2.0) - 0.1295, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((-2 - this.vArr2[i].C), 2)) / 2.0) - 0.054, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((-5.0 / 2 - this.vArr2[i].C), 2)) / 2.0) - 0.0175, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((-3 - this.vArr2[i].C), 2)) / 2.0) - 0.0044, 2);
            this.vArr2[i].Cost += Math.Pow(this.vArr2[i].A * Math.Exp((-this.vArr2[i].B * Math.Pow((-7.0 / 2 - this.vArr2[i].C), 2)) / 2.0) - 0.0009, 2);
            z[2] += 1;

        }
        public void ComputeCost4(int i) //i=which cost
        {

            this.vArr4[i].Cost = Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((7.0 / 2 - this.vArr4[i].C), 2)) / 2.0) - 0.0009, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((3 - this.vArr4[i].C), 2)) / 2.0) - 0.0044, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((5.0 / 2 - this.vArr4[i].C), 2)) / 2.0) - 0.0175, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((2 - this.vArr4[i].C), 2)) / 2.0) - 0.054, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((3.0 / 2 - this.vArr4[i].C), 2)) / 2.0) - 0.1295, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((1 - this.vArr4[i].C), 2)) / 2.0) - 0.242, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((1.0 / 2 - this.vArr4[i].C), 2)) / 2.0) - 0.3521, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((-this.vArr4[i].C), 2)) / 2.0) - 0.3989, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((-1.0 / 2 - this.vArr4[i].C), 2)) / 2.0) - 0.3521, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((-1 - this.vArr4[i].C), 2)) / 2.0) - 0.242, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((-3.0 / 2 - this.vArr4[i].C), 2)) / 2.0) - 0.1295, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((-2 - this.vArr4[i].C), 2)) / 2.0) - 0.054, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((-5.0 / 2 - this.vArr4[i].C), 2)) / 2.0) - 0.0175, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((-3 - this.vArr4[i].C), 2)) / 2.0) - 0.0044, 2);
            this.vArr4[i].Cost += Math.Pow(this.vArr4[i].A * Math.Exp((-this.vArr4[i].B * Math.Pow((-7.0 / 2 - this.vArr4[i].C), 2)) / 2.0) - 0.0009, 2);
            z[4] += 1;

        }    

        public bool DoOptimizationOnVertixElements( int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr[3].Cost;
            this.vArr[4] = (Vertix)this.vArr[3].Clone(); // copy in case we cannot improve
            this.vArr[3] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost(3);

            if (this.vArr[3].Cost < costTest) /// Try Expansion
            {
                this.vArr[4] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                ComputeCost(4);// find cost0

                if (this.vArr[4].Cost < this.vArr[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
            }

            if (this.vArr[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                 this.vArr[3] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                 ComputeCost(3);  // contract to c1

                 if (costTest <= this.vArr[3].Cost)   // Check c1
                 {
                     this.vArr[3] = (Vertix)this.vArr[4].Clone();
                     this.vArr[3] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                     ComputeCost(3);// find cost
                    
                     if  (this.vArr[3].Cost < costTest)  // c2 is better than c1
                     {
                         optimize = true;
                         optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                         numOfOperations[2] += 1;
                     }
                     else
                     {                         
                             this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                             optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";                          
                     }

                 }
                 else
                 {
                     optimize = true;  // C1 is better
                     optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                     numOfOperations[3] += 1;
                 }
            }

            if (this.vArr[3].Cost >= costTest)
            {
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                this.VArr[3] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[3], whichParameterOfVertix);
                ComputeCost(3);
                if (costTest <= this.vArr[3].Cost)    // Contract W to B
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr[3] = Vertix.ShrinkWToB(this.vArr[0], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                    ComputeCost(3);
                    if (this.vArr[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }


            this.vArr[4].Cost = 0; this.vArr[4].A = 0.4 + 0.4 * 0.1; this.vArr[4].B = 1.1; this.vArr[4].C = 0.0005; //this.vArr[4].TY = 0; this.vArr[4].TX = 0;
            ComputeCost(4);            
            return optimize;
        }
        public bool DoOptimizationOnVertixElements1(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr1[3].Cost;
            this.vArr1[4] = (Vertix)this.vArr1[3].Clone(); // copy in case we cannot improve
            this.vArr1[3] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost1(3);

            if (this.vArr1[3].Cost < costTest) /// Try Expansion
            {
                this.vArr1[4] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(4);// find cost0

                if (this.vArr1[4].Cost < this.vArr1[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
            }

            if (this.vArr1[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                this.vArr1[3] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(3);  // contract to c1

                if (costTest <= this.vArr1[3].Cost)   // Check c1
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    this.vArr1[3] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                    ComputeCost1(3);// find cost

                    if (this.vArr1[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 1;
                    }
                    else
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 1;
                }
            }

            if (this.vArr1[3].Cost >= costTest)
            {
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                this.vArr1[3] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(3);
                if (costTest <= this.vArr1[3].Cost)    // Contract W to B
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    this.vArr1[3] = Vertix.ShrinkWToB(this.vArr1[0], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                    ComputeCost1(3);
                    if (this.vArr1[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }


            this.vArr1[4].Cost = 0; this.vArr1[4].A = 0.4 - 0.4 * 0.05 * 1; this.vArr1[4].B = 1; this.vArr1[4].C = -0.00025;
            ComputeCost1(4);
            return optimize;
        }
        public bool DoOptimizationOnVertixElements2(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr2[3].Cost;
            this.vArr2[4] = (Vertix)this.vArr2[3].Clone(); // copy in case we cannot improve
            this.vArr2[3] = Vertix.TryRefluction(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost2(3);

            if (this.vArr2[3].Cost < costTest) /// Try Expansion
            {
                this.vArr2[4] = Vertix.TryExpansion(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], whichParameterOfVertix);
                ComputeCost2(4);// find cost0

                if (this.vArr2[4].Cost < this.vArr2[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
            }

            if (this.vArr2[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                this.vArr2[3] = Vertix.ContractToC1(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], whichParameterOfVertix);
                ComputeCost2(3);  // contract to c1

                if (costTest <= this.vArr2[3].Cost)   // Check c1
                {
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                    this.vArr2[3] = Vertix.ContractToC2(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], whichParameterOfVertix);
                    ComputeCost2(3);// find cost

                    if (this.vArr2[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 1;
                    }
                    else
                    {
                        this.vArr2[3] = (Vertix)this.vArr2[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 1;
                }
            }

            if (this.vArr2[3].Cost >= costTest)
            {
                this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                this.vArr2[3] = Vertix.ShrinkGToB(this.vArr2[0], this.vArr2[1], this.vArr2[3], whichParameterOfVertix);
                ComputeCost2(3);
                if (costTest <= this.vArr2[3].Cost)    // Contract W to B
                {
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                    this.vArr2[3] = Vertix.ShrinkWToB(this.vArr2[0], this.vArr2[2], this.vArr2[3], whichParameterOfVertix);
                    ComputeCost2(3);
                    if (this.vArr2[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr2[3] = (Vertix)this.vArr2[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }


            this.vArr2[4].Cost = 0; this.vArr2[4].A = 0.4; this.vArr2[4].B = 0.95; this.vArr2[4].C = 0;           
            ComputeCost2(4);
            return optimize;
        }
        public bool DoOptimizationOnVertixElements4(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr4[3].Cost;
            this.vArr4[4] = (Vertix)this.vArr4[3].Clone(); // copy in case we cannot improve
            this.vArr4[3] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost4(3);

            if (this.vArr4[3].Cost < costTest) /// Try Expansion
            {
                this.vArr4[4] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(4);// find cost0

                if (this.vArr4[4].Cost < this.vArr4[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
            }

            if (this.vArr4[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                this.vArr4[3] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(3);  // contract to c1

                if (costTest <= this.vArr4[3].Cost)   // Check c1
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    this.vArr4[3] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                    ComputeCost4(3);// find cost

                    if (this.vArr4[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 1;
                    }
                    else
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 1;
                }
            }

            if (this.vArr4[3].Cost >= costTest)
            {
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                this.VArr4[3] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(3);
                if (costTest <= this.vArr4[3].Cost)    // Contract W to B
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    this.VArr4[3] = Vertix.ShrinkWToB(this.vArr4[0], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                    ComputeCost4(3);
                    if (this.vArr4[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }


            this.vArr4[4].Cost = 0; this.vArr4[4].A = 0.4 - 0.4 * 0.05 * 3; this.vArr4[4].B = 0.85; this.vArr4[4].C = -0.00075; 
            ComputeCost4(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck()
        {
            bool optimize = false;
            double costTest = this.vArr[3].Cost;


            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0); // 1. try reflection
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
            ComputeCost(4);
            if (this.vArr[4].Cost < costTest) /// Try Expansion
            {
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 0);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 1);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 2);
                ComputeCost(3);// find cost0

                if (this.vArr[3].Cost < this.vArr[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; numOfOperations[1] += 3;
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; numOfOperations[0] += 3;
                }

            }

            if (this.vArr[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
                ComputeCost(4);  // contract to c1

                if (costTest <= this.vArr[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
                    ComputeCost(4);// find cost

                    if (this.vArr[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; numOfOperations[2] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; numOfOperations[3] += 3;
                }
            }

            if (this.vArr[3].Cost >= costTest)
            {
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 0);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 1);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 2);
                ComputeCost(4);
                if (costTest <= this.vArr[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 0);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 1);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 2);
                    ComputeCost(4);
                    if (this.vArr[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; numOfOperations[5] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; numOfOperations[4] += 3;
                }
            }

            this.vArr[4].Cost = 0; this.vArr[4].A = 0.4 + 0.4 * 0.1; this.vArr[4].B = 1.1; this.vArr[4].C = 0.0005; //this.vArr[4].TY = 0; this.vArr[4].TX = 0;
            ComputeCost(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck1()
        {
            bool optimize = false;
            double costTest = this.vArr1[3].Cost;


            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0); // 1. try reflection
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
            ComputeCost1(4);
            if (this.vArr1[4].Cost < costTest) /// Try Expansion
            {
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 0);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 1);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 2);
                ComputeCost1(3);// find cost0

                if (this.vArr1[3].Cost < this.vArr1[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; numOfOperations[1] += 3;
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; numOfOperations[0] += 3;
                }

            }

            if (this.vArr1[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
                ComputeCost1(4);  // contract to c1

                if (costTest <= this.vArr1[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
                    ComputeCost1(4);// find cost

                    if (this.vArr1[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; numOfOperations[2] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; numOfOperations[3] += 3;
                }
            }

            if (this.vArr1[3].Cost >= costTest)
            {
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 0);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 1);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 2);
                ComputeCost1(4);
                if (costTest <= this.vArr1[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 0);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 1);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 2);
                    ComputeCost1(4);
                    if (this.vArr1[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; numOfOperations[5] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; numOfOperations[4] += 3;
                }
            }

            this.vArr1[4].Cost = 0; this.vArr1[4].A = 0.4 - 0.4 * 0.05 * 1; this.vArr1[4].B = 1; this.vArr1[4].C = -0.00025;
            ComputeCost1(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck2()
        {
            bool optimize = false;
            double costTest = this.vArr2[3].Cost;


            this.vArr2[4] = Vertix.TryRefluction(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 0); // 1. try reflection
            this.vArr2[4] = Vertix.TryRefluction(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 1);
            this.vArr2[4] = Vertix.TryRefluction(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 2);
            ComputeCost2(4);
            if (this.vArr2[4].Cost < costTest) /// Try Expansion
            {
                this.vArr2[3] = Vertix.TryExpansion(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], 0);
                this.vArr2[3] = Vertix.TryExpansion(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], 1);
                this.vArr2[3] = Vertix.TryExpansion(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], 2);
                ComputeCost2(3);// find cost0

                if (this.vArr2[3].Cost < this.vArr2[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; numOfOperations[1] += 3;
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; numOfOperations[0] += 3;
                }

            }

            if (this.vArr2[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr2[4] = Vertix.ContractToC1(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 0);
                this.vArr2[4] = Vertix.ContractToC1(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 1);
                this.vArr2[4] = Vertix.ContractToC1(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 2);
                ComputeCost2(4);  // contract to c1

                if (costTest <= this.vArr2[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr2[4] = Vertix.ContractToC2(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 0);
                    this.vArr2[4] = Vertix.ContractToC2(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 1);
                    this.vArr2[4] = Vertix.ContractToC2(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 2);
                    ComputeCost2(4);// find cost

                    if (this.vArr2[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; numOfOperations[2] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; numOfOperations[3] += 3;
                }
            }

            if (this.vArr2[3].Cost >= costTest)
            {
                this.vArr2[4] = Vertix.ShrinkGToB(this.vArr2[0], this.vArr2[1], this.vArr2[4], 0);
                this.vArr2[4] = Vertix.ShrinkGToB(this.vArr2[0], this.vArr2[1], this.vArr2[4], 1);
                this.vArr2[4] = Vertix.ShrinkGToB(this.vArr2[0], this.vArr2[1], this.vArr2[4], 2);
                ComputeCost2(4);
                if (costTest <= this.vArr2[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr2[4] = Vertix.ShrinkWToB(this.vArr2[2], this.vArr2[0], this.vArr2[4], 0);
                    this.vArr2[4] = Vertix.ShrinkWToB(this.vArr2[2], this.vArr2[0], this.vArr2[4], 1);
                    this.vArr2[4] = Vertix.ShrinkWToB(this.vArr2[2], this.vArr2[0], this.vArr2[4], 2);
                    ComputeCost2(4);
                    if (this.vArr2[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; numOfOperations[5] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; numOfOperations[4] += 3;
                }
            }

            this.vArr2[4].Cost = 0; this.vArr2[4].A = 0.4; this.vArr2[4].B = 0.95; this.vArr2[4].C = 0;
            ComputeCost2(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck4()
        {
            bool optimize = false;
            double costTest = this.vArr4[3].Cost;


            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0); // 1. try reflection
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
            ComputeCost4(4);
            if (this.vArr4[4].Cost < costTest) /// Try Expansion
            {
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 0);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 1);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 2);
                ComputeCost4(3);// find cost0

                if (this.vArr4[3].Cost < this.vArr4[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; numOfOperations[1] += 3;
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; numOfOperations[0] += 3;
                }

            }

            if (this.vArr4[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
                ComputeCost4(4);  // contract to c1

                if (costTest <= this.vArr4[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
                    ComputeCost4(4);// find cost

                    if (this.vArr4[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; numOfOperations[2] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; numOfOperations[3] += 3;
                }
            }

            if (this.vArr4[3].Cost >= costTest)
            {
                this.vArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 0);
                this.vArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 1);
                this.vArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 2);
                ComputeCost4(4);
                if (costTest <= this.vArr4[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 0);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 1);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 2);
                    ComputeCost4(4);
                    if (this.vArr4[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; numOfOperations[5] += 3;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; numOfOperations[4] += 3;
                }
            }

            this.vArr4[4].Cost = 0; this.vArr4[4].A = 0.4 - 0.4 * 0.05 * 3; this.vArr4[4].B = 0.85; this.vArr4[4].C = -0.00075;
            ComputeCost4(4);
            return optimize;
        }
        public object Clone(int i)
        {
            Simplex snew = (Simplex)this.MemberwiseClone();
            snew.vArr[i] = (Vertix)this.vArr[i].Clone();
            return snew;
        }

        public override string ToString()
        {
            return "NofIteration =" + this.z[0].ToString() + "\nA " + optimizeElementsInVertix[0] + "\nB " + optimizeElementsInVertix[1] + "\nC " + optimizeElementsInVertix[2] + "\nBest1: "
                + "a: " + this.vArr[0].A.ToString() + "\tb: " + this.vArr[0].B.ToString() + "\tCost1: " + this.vArr[0].Cost.ToString() + "\nBest2: " + "a: " + this.vArr1[0].A.ToString()
                + "\tb: " + this.vArr1[0].B.ToString() + "\tCost2: " + this.vArr1[0].Cost.ToString() + "\tNofIteration =" + this.z[1].ToString() + "\nBest4: " + "a: " +
                this.vArr2[0].A.ToString() + "\tb: " + this.vArr2[0].B.ToString() + "\tCost4: " + this.vArr2[0].Cost.ToString() + "\tNofIteration =" + this.z[2].ToString() + "\nBest5: "
                + "a: " + this.vArr4[0].A.ToString() + "\tb: " + this.vArr4[0].B.ToString() + "\tCost5: " + this.vArr4[0].Cost.ToString() + "\tNofIteration =" + this.z[4].ToString();
            ;               

        }
    }
}