﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RosenBrockFunction
{
    public partial class Form1 : Form
    {
        Simplex simp = new Simplex();
        Vertix firstVerOfW = new Vertix();
        Vertix lastVerOfW = new Vertix();
        public Form1()
        {
            InitializeComponent();
        }

        private void cmdNelderMead_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < simp.VArr.Length; i++)
            {
                simp.ComputeCost(i);
                simp.ComputeCost1(i);
                simp.ComputeCost3(i);
                simp.ComputeCost4(i);
            }

            Array.Sort(simp.VArr);
            Array.Sort(simp.VArr1);
            Array.Sort(simp.VArr3);
            Array.Sort(simp.VArr4);
            //MessageBox.Show(simp.ToString());

            DateTime start = DateTime.Now;
            int window1 = 10; int window2 = 10; int window3 = 10; int window4 = 10; int window5 = 10; int iter = 0;
            for (int j = 0; j < int.Parse(txtIterationNumber.Text); j++)
            {
                firstVerOfW = (Vertix)simp.VArr[3].Clone();

                for (int w = 0; w < window1; w++)
                {
                    double whatCostFind = simp.VArr[3].Cost;
                    for (int i = 9; i > -1; i--)
                    {
                        bool didParameterOptimized = simp.DoOptimizationOnVertixElements(i);
                    }

                    if (whatCostFind <= simp.VArr[3].Cost && simp.OptimizeElementsInVertix[0] == "Element: does nothing" && simp.OptimizeElementsInVertix[1] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[2] == "Element: does nothing" && simp.OptimizeElementsInVertix[3] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[4] == "Element: does nothing" && simp.OptimizeElementsInVertix[5] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[6] == "Element: does nothing" && simp.OptimizeElementsInVertix[7] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[8] == "Element: does nothing" && simp.OptimizeElementsInVertix[9] == "Element: does nothing")
                    {
                        bool didParameterOptimized = simp.DoOptimizationWheenThStuck();
                    }
                    Array.Sort(simp.VArr);
                    if (simp.VArr[0].Cost == 0)
                        break;
                }

                lastVerOfW = (Vertix)simp.VArr[3].Clone();

                double m1 = lastVerOfW.X1 - firstVerOfW.X1; double m2 = lastVerOfW.X2 - firstVerOfW.X2; double m3 = lastVerOfW.X3 - firstVerOfW.X3;
                double m4 = lastVerOfW.X4 - firstVerOfW.X4; double m5 = lastVerOfW.X5 - firstVerOfW.X5; double m6 = lastVerOfW.X6 - firstVerOfW.X6;
                double m7 = lastVerOfW.X7 - firstVerOfW.X7; double m8 = lastVerOfW.X8 - firstVerOfW.X8; double m9 = lastVerOfW.X9 - firstVerOfW.X9;
                double m10 = lastVerOfW.X10 - firstVerOfW.X10;
                if (m1 == 0 && m2 == 0 && m3 == 0 && m4 == 0 && m5 == 0 && m6 == 0 && m7 == 0 && m8 == 0 && m9 == 0 && m10 == 0)
                    window1 = 0;
                ////// Simplex 2
                firstVerOfW = (Vertix)simp.VArr1[3].Clone();

                for (int w = 0; w < window2; w++)
                {
                    double whatCostFind = simp.VArr1[3].Cost;
                    for (int i = 9; i > -1; i--)
                    {
                        bool didParameterOptimized = simp.DoOptimizationOnVertixElements1(i);
                    }

                    if (whatCostFind <= simp.VArr1[3].Cost && simp.OptimizeElementsInVertix[0] == "Element: does nothing" && simp.OptimizeElementsInVertix[1] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[2] == "Element: does nothing" && simp.OptimizeElementsInVertix[3] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[4] == "Element: does nothing" && simp.OptimizeElementsInVertix[5] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[6] == "Element: does nothing" && simp.OptimizeElementsInVertix[7] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[8] == "Element: does nothing" && simp.OptimizeElementsInVertix[9] == "Element: does nothing")
                    {
                        bool didParameterOptimized = simp.DoOptimizationWheenThStuck1();
                    }
                    Array.Sort(simp.VArr1);

                    if (simp.VArr1[0].Cost == 0)
                        break;
                }

                lastVerOfW = (Vertix)simp.VArr1[3].Clone();

                m1 = lastVerOfW.X1 - firstVerOfW.X1; m2 = lastVerOfW.X2 - firstVerOfW.X2; m3 = lastVerOfW.X3 - firstVerOfW.X3;
                m4 = lastVerOfW.X4 - firstVerOfW.X4; m5 = lastVerOfW.X5 - firstVerOfW.X5; m6 = lastVerOfW.X6 - firstVerOfW.X6;
                m7 = lastVerOfW.X7 - firstVerOfW.X7; m8 = lastVerOfW.X8 - firstVerOfW.X8; m9 = lastVerOfW.X9 - firstVerOfW.X9;
                m10 = lastVerOfW.X10 - firstVerOfW.X10;
                if (m1 == 0 && m2 == 0 && m3 == 0 && m4 == 0 && m5 == 0 && m6 == 0 && m7 == 0 && m8 == 0 && m9 == 0 && m10 == 0)
                    window2 = 0;
                ////// Simplex 4
                firstVerOfW = (Vertix)simp.VArr3[3].Clone();

                for (int w = 0; w < window4; w++)
                {
                    double whatCostFind = simp.VArr3[3].Cost;
                    for (int i = 9; i > -1; i--)
                    {
                        bool didParameterOptimized = simp.DoOptimizationOnVertixElements3(i);
                    }

                    if (whatCostFind <= simp.VArr3[3].Cost && simp.OptimizeElementsInVertix[0] == "Element: does nothing" && simp.OptimizeElementsInVertix[1] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[2] == "Element: does nothing" && simp.OptimizeElementsInVertix[3] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[4] == "Element: does nothing" && simp.OptimizeElementsInVertix[5] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[6] == "Element: does nothing" && simp.OptimizeElementsInVertix[7] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[8] == "Element: does nothing" && simp.OptimizeElementsInVertix[9] == "Element: does nothing")
                    {
                        bool didParameterOptimized = simp.DoOptimizationWheenThStuck3();
                    }
                    Array.Sort(simp.VArr3);

                    if (simp.VArr3[0].Cost == 0)
                        break;
                }

                lastVerOfW = (Vertix)simp.VArr3[3].Clone();

                m1 = lastVerOfW.X1 - firstVerOfW.X1; m2 = lastVerOfW.X2 - firstVerOfW.X2; m3 = lastVerOfW.X3 - firstVerOfW.X3;
                m4 = lastVerOfW.X4 - firstVerOfW.X4; m5 = lastVerOfW.X5 - firstVerOfW.X5; m6 = lastVerOfW.X6 - firstVerOfW.X6;
                m7 = lastVerOfW.X7 - firstVerOfW.X7; m8 = lastVerOfW.X8 - firstVerOfW.X8; m9 = lastVerOfW.X9 - firstVerOfW.X9;
                m10 = lastVerOfW.X10 - firstVerOfW.X10;
                if (m1 == 0 && m2 == 0 && m3 == 0 && m4 == 0 && m5 == 0 && m6 == 0 && m7 == 0 && m8 == 0 && m9 == 0 && m10 == 0)
                    window4 = 0;
                ////// Simplex 5
                firstVerOfW = (Vertix)simp.VArr4[3].Clone();

                for (int w = 0; w < window5; w++)
                {
                    double whatCostFind = simp.VArr4[3].Cost;
                    for (int i = 9; i > -1; i--)
                    {
                        bool didParameterOptimized = simp.DoOptimizationOnVertixElements4(i);
                    }

                    if (whatCostFind <= simp.VArr4[3].Cost && simp.OptimizeElementsInVertix[0] == "Element: does nothing" && simp.OptimizeElementsInVertix[1] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[2] == "Element: does nothing" && simp.OptimizeElementsInVertix[3] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[4] == "Element: does nothing" && simp.OptimizeElementsInVertix[5] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[6] == "Element: does nothing" && simp.OptimizeElementsInVertix[7] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[8] == "Element: does nothing" && simp.OptimizeElementsInVertix[9] == "Element: does nothing")
                    {
                        bool didParameterOptimized = simp.DoOptimizationWheenThStuck4();
                    }
                    iter++;
                    Array.Sort(simp.VArr4);

                    if (simp.VArr4[0].Cost == 0)
                        break;
                }

                lastVerOfW = (Vertix)simp.VArr4[3].Clone();

                m1 = lastVerOfW.X1 - firstVerOfW.X1; m2 = lastVerOfW.X2 - firstVerOfW.X2; m3 = lastVerOfW.X3 - firstVerOfW.X3;
                m4 = lastVerOfW.X4 - firstVerOfW.X4; m5 = lastVerOfW.X5 - firstVerOfW.X5; m6 = lastVerOfW.X6 - firstVerOfW.X6;
                m7 = lastVerOfW.X7 - firstVerOfW.X7; m8 = lastVerOfW.X8 - firstVerOfW.X8; m9 = lastVerOfW.X9 - firstVerOfW.X9;
                m10 = lastVerOfW.X10 - firstVerOfW.X10;
                if (m1 == 0 && m2 == 0 && m3 == 0 && m4 == 0 && m5 == 0 && m6 == 0 && m7 == 0 && m8 == 0 && m9 == 0 && m10 == 0)
                    window5 = 0;

                if (window1 == 0 && window2 == 0 && window4 == 0 && window5 == 0)
                    break;

                if (simp.VArr[0].Cost == 0 || simp.VArr1[0].Cost == 0 || simp.VArr3[0].Cost == 0 || simp.VArr4[0].Cost == 0)
                    break;
                
            }
            TimeSpan timeItTook = DateTime.Now - start;
            MessageBox.Show(simp.ToString());
            MessageBox.Show(timeItTook.ToString());
            MessageBox.Show("Number of Simplexes: " + iter.ToString());
        }
    }
}
