﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RosenBrockFunction
{
    class Simplex
    {          
        string whichIsBest;
        public string WhichIsBest
        {
            get { return whichIsBest; }
            set { whichIsBest = value; }
        }
      
        Vertix[] vArr = new Vertix[5]
        {
                new Vertix(-3, -1, -3, -1,  0),    
                new Vertix(-3 - 3 * 0.05, -1.05, -3 - 3 * 0.05, -1.05,  0), 
                new Vertix(-3 - 3 * 0.1, -1.1, -3 - 3 * 0.1, -1.1,  0),    
                new Vertix(-3 - 3 * 0.1, -1.1, -3 - 3 * 0.1, -1.1,  0),    
                new Vertix(-3 - 3 * 0.1, -1.1, -3 - 3 * 0.1, -1.1,  0),           
        };
        public Vertix[] VArr
        {
            get { return vArr; }
            set { vArr = value; }
        }
        Vertix[] vArr1 = new Vertix[5]
        {
                new Vertix(-3, -1, -3, -1,  0),    
                new Vertix(-3 + 3 * 0.05, -1, -3 + 3 * 0.05, -1,  0), 
                new Vertix(-3 + 3 * 0.05, -1.05, -3 + 3 * 0.05, -1.05,  0),   
                new Vertix(-3 + 3 * 0.1, -1.05, -3 + 3 * 0.1, -1.05,  0),  
                new Vertix(-3 + 3 * 0.1, -1.1, -3 + 3 * 0.1, -1.1,  0),            
        };
        public Vertix[] VArr1
        {
            get { return vArr1; }
            set { vArr1 = value; }
        }
        Vertix[] vArr2 = new Vertix[5]
        {
                new Vertix(-3, -1, -3, -1,  0),    
                new Vertix(-3 + 3 * 0.05, -0.95, -3 + 3 * 0.05, -0.95,  0),  
                new Vertix(-3 + 3 * 0.1, -0.90, -3 + 3 * 0.1, -0.90,  0),     
                new Vertix(-3 + 3 * 0.15, -0.85, -3 + 3 * 0.15, -0.85,  0),   
                new Vertix(-3 + 3 * 0.2, -0.80, -3 + 3 * 0.2, -0.80,  0),            
        };
        public Vertix[] VArr2
        {
            get { return vArr2; }
            set { vArr2 = value; }
        }

        Vertix[] vArr3 = new Vertix[5]
        {
                new Vertix(-3, -1, -3, -1,  0),    
                new Vertix(-3, -0.95, -3, -0.95,  0),  
                new Vertix(-3 - 3 * 0.05, -0.95, -3 - 3 * 0.05, -0.95,  0),     
                new Vertix(-3 - 3 * 0.05, -0.90, -3 - 3 * 0.05, -0.90,  0),   
                new Vertix(-3 - 3 * 0.1, -0.90, -3 - 3 * 0.1, -0.90,  0),            
        };
        public Vertix[] VArr3
        {
            get { return vArr3; }
            set { vArr3 = value; }
        }
        double[] z = new double[5] { 0, 0, 0, 0, 0 };
        string[] optimizeElementsInVertix = new string[4]
        {
            "It did not optimize yet", "It did not optimize yet", "It did not optimize yet", "It did not optimize yet" 
        };
        public double[] numOfOperations = new double[6]
        {
            0, 0, 0, 0, 0, 0
        };
        public string[] OptimizeElementsInVertix
        {
            get { return optimizeElementsInVertix; }
            set { optimizeElementsInVertix = value; }
        }
        public Simplex() {}                     
        
        public void ComputeCost( int i) 
        {
            this.vArr[i].Cost = 100 * Math.Pow(this.vArr[i].B - Math.Pow(this.vArr[i].A, 2), 2) +
                                Math.Pow(1 - this.vArr[i].A, 2) +
                                Math.Pow(1 - this.vArr[i].C, 2) +
                                90 * Math.Pow(this.vArr[i].D - Math.Pow(this.vArr[i].C, 2), 2) +
                                10 * (Math.Pow(this.vArr[i].B + this.vArr[i].D - 2, 2)) +
                                10 * Math.Pow(this.vArr[i].B - this.vArr[i].D, 2);  
            z[0] += 1;
        }
        public void ComputeCost1(int i) 
        {
            this.vArr1[i].Cost = 100 * Math.Pow(this.vArr1[i].B - Math.Pow(this.vArr1[i].A, 2), 2) +
                                Math.Pow(1 - this.vArr1[i].A, 2) +
                                Math.Pow(1 - this.vArr1[i].C, 2) +
                                90 * Math.Pow(this.vArr1[i].D - Math.Pow(this.vArr1[i].C, 2), 2) +
                                10 * (Math.Pow(this.vArr1[i].B + this.vArr1[i].D - 2, 2)) +
                                10 * Math.Pow(this.vArr1[i].B - this.vArr1[i].D, 2);  
            z[1] += 1;
        }
        public void ComputeCost2(int i)
        {
            this.vArr2[i].Cost = 100 * Math.Pow(this.vArr2[i].B - Math.Pow(this.vArr2[i].A, 2), 2) +
                                Math.Pow(1 - this.vArr2[i].A, 2) +
                                Math.Pow(1 - this.vArr2[i].C, 2) +
                                90 * Math.Pow(this.vArr2[i].D - Math.Pow(this.vArr2[i].C, 2), 2) +
                                10 * (Math.Pow(this.vArr2[i].B + this.vArr2[i].D - 2, 2)) +
                                10 * Math.Pow(this.vArr2[i].B - this.vArr2[i].D, 2);
            z[2] += 1;
        }

        public void ComputeCost3(int i)
        {
            this.vArr3[i].Cost = 100 * Math.Pow(this.vArr3[i].B - Math.Pow(this.vArr3[i].A, 2), 2) +
                                Math.Pow(1 - this.vArr3[i].A, 2) +
                                Math.Pow(1 - this.vArr3[i].C, 2) +
                                90 * Math.Pow(this.vArr3[i].D - Math.Pow(this.vArr3[i].C, 2), 2) +
                                10 * (Math.Pow(this.vArr3[i].B + this.vArr3[i].D - 2, 2)) +
                                10 * Math.Pow(this.vArr3[i].B - this.vArr3[i].D, 2);
            z[3] += 1;
        }
       

        public bool DoOptimizationOnVertixElements( int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr[3].Cost;
            this.vArr[4] = (Vertix)this.vArr[3].Clone(); // copy in case we cannot improve
            this.vArr[3] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost(3);

            if (this.vArr[3].Cost < costTest) /// Try Expansion
            {
                this.vArr[4] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                ComputeCost(4);// find cost0

                if (this.vArr[4].Cost < this.vArr[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimize = false;
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
            }

            if (this.vArr[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                 this.vArr[3] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                 ComputeCost(3);  // contract to c1

                 if (costTest <= this.vArr[3].Cost)   // Check c1
                 {
                     this.vArr[3] = (Vertix)this.vArr[4].Clone();
                     this.vArr[3] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                     ComputeCost(3);// find cost
                    
                     if  (this.vArr[3].Cost < costTest)  // c2 is better than c1
                     {
                         optimize = true;
                         optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                         numOfOperations[2] += 1;
                     }
                     else
                     {                         
                             this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                             optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";                          
                     }

                 }
                 else
                 {
                     optimize = true;  // C1 is better
                     optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                     numOfOperations[3] += 1;
                 }
            }

            if (this.vArr[3].Cost >= costTest)
            {
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                this.vArr[3] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[3], whichParameterOfVertix);
                ComputeCost(3);
                if (costTest <= this.vArr[3].Cost)    // Contract W to B
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr[3] = Vertix.ShrinkWToB(this.vArr[0], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                    ComputeCost(3);
                    if (this.vArr[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }


            this.vArr[4].Cost = 0; this.vArr[4].A = -3 - 3 * 0; this.vArr[4].B = -1; this.vArr[4].C = -3 - 3 * 0; this.vArr[4].D = -1;
            ComputeCost(4);
            return optimize;
        }

        public bool DoOptimizationOnVertixElements1(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr1[3].Cost;
            this.vArr1[4] = (Vertix)this.vArr1[3].Clone(); // copy in case we cannot improve
            this.vArr1[3] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost1(3);

            if (this.vArr1[3].Cost < costTest) /// Try Expansion
            {
                this.vArr1[4] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(4);// find cost0

                if (this.vArr1[4].Cost < this.vArr1[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
            }

            if (this.vArr1[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                this.vArr1[3] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(3);  // contract to c1

                if (costTest <= this.vArr1[3].Cost)   // Check c1
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    this.vArr1[3] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                    ComputeCost1(3);// find cost

                    if (this.vArr1[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 1;
                    }
                    else
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 1;
                }
            }

            if (this.vArr1[3].Cost >= costTest)
            {
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                this.vArr1[3] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(3);
                if (costTest <= this.vArr1[3].Cost)    // Contract W to B
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    this.vArr1[3] = Vertix.ShrinkWToB(this.vArr1[0], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                    ComputeCost1(3);
                    if (this.vArr1[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }
            this.vArr1[4].Cost = 0; this.vArr1[4].A = -3 + 3 * 0.1; this.vArr1[4].B = -1.05; this.vArr1[4].C = -3 + 3 * 0.1; this.vArr1[4].D = -1.05;
            ComputeCost1(4);
            return optimize;
        }
        public bool DoOptimizationOnVertixElements2(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr2[3].Cost;
            this.vArr2[4] = (Vertix)this.vArr2[3].Clone(); // copy in case we cannot improve
            this.vArr2[3] = Vertix.TryRefluction(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost2(3);

            if (this.vArr2[3].Cost < costTest) /// Try Expansion
            {
                this.vArr2[4] = Vertix.TryExpansion(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], whichParameterOfVertix);
                ComputeCost2(4);// find cost0

                if (this.vArr2[4].Cost < this.vArr2[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
            }

            if (this.vArr2[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                this.vArr2[3] = Vertix.ContractToC1(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], whichParameterOfVertix);
                ComputeCost2(3);  // contract to c1

                if (costTest <= this.vArr2[3].Cost)   // Check c1
                {
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                    this.vArr2[3] = Vertix.ContractToC2(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], whichParameterOfVertix);
                    ComputeCost2(3);// find cost

                    if (this.vArr2[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 1;
                    }
                    else
                    {
                        this.vArr2[3] = (Vertix)this.vArr2[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 1;
                }
            }

            if (this.vArr2[3].Cost >= costTest)
            {
                this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                this.VArr2[3] = Vertix.ShrinkGToB(this.vArr2[0], this.vArr2[1], this.vArr2[3], whichParameterOfVertix);
                ComputeCost2(3);
                if (costTest <= this.vArr2[3].Cost)    // Contract W to B
                {
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                    this.VArr2[3] = Vertix.ShrinkWToB(this.vArr2[0], this.vArr2[2], this.vArr2[3], whichParameterOfVertix);
                    ComputeCost2(3);
                    if (this.vArr2[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr2[3] = (Vertix)this.vArr2[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }


            this.vArr2[4].Cost = 0; this.vArr2[4].A = -3; this.vArr2[4].B = -1; this.vArr2[4].C = -3; this.vArr2[4].D = -1;
            ComputeCost2(4);
            return optimize;
        }
        public bool DoOptimizationOnVertixElements3(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr3[3].Cost;
            this.vArr3[4] = (Vertix)this.vArr3[3].Clone(); // copy in case we cannot improve
            this.vArr3[3] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost3(3);

            if (this.vArr3[3].Cost < costTest) /// Try Expansion
            {
                this.vArr3[4] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(4);// find cost0

                if (this.vArr3[4].Cost < this.vArr3[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    numOfOperations[1] += 1;
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                    numOfOperations[0] += 1;
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
            }

            if (this.vArr3[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                this.vArr3[3] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(3);  // contract to c1

                if (costTest <= this.vArr3[3].Cost)   // Check c1
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    this.vArr3[3] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                    ComputeCost3(3);// find cost

                    if (this.vArr3[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 1;
                    }
                    else
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 1;
                }
            }

            if (this.vArr3[3].Cost >= costTest)
            {
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                this.VArr3[3] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(3);
                if (costTest <= this.vArr3[3].Cost)    // Contract W to B
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    this.VArr3[3] = Vertix.ShrinkWToB(this.vArr3[0], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                    ComputeCost3(3);
                    if (this.vArr3[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 1;
                    }
                    else
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 1;
                }
            }


            this.vArr3[4].Cost = 0; this.vArr3[4].A = -3; this.vArr3[4].B = -0.95; this.vArr3[4].C = -3; this.vArr3[4].D = -0.95;
            ComputeCost3(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck()
        {
            bool optimize = false;
            double costTest = this.vArr[3].Cost;

            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0); // 1. try reflection
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 3);
            ComputeCost(4);
            if (this.vArr[4].Cost < costTest) /// Try Expansion
            {
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 0);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 1);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 2);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 3);
                ComputeCost(3);// find cost0

                if (this.vArr[3].Cost < this.vArr[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    numOfOperations[1] += 4;
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                    numOfOperations[0] += 4;
                }

            }

            if (this.vArr[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 3);
                ComputeCost(4);  // contract to c1

                if (costTest < this.vArr[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 3);
                    ComputeCost(4);// find cost

                    if (this.vArr[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 4;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; optimizeElementsInVertix[3] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 4;
                }
            }

            if (this.vArr[3].Cost >= costTest)
            {
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 0);
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 1);
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 2);
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 3);
                ComputeCost(4);
                if (costTest <= this.vArr[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 0);
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 1);
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 2);
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 3);
                    ComputeCost(4);
                    if (this.vArr[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 4;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 4;
                }
            }

            this.vArr[4].Cost = 0; this.vArr[4].A = -3 - 3 * 0; this.vArr[4].B = -1; this.vArr[4].C = -3 - 3 * 0; this.vArr[4].D = -1;
            ComputeCost(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck1()
        {
            bool optimize = false;
            double costTest = this.vArr1[3].Cost;


            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0); // 1. try reflection
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 3);
            ComputeCost1(4);
            if (this.vArr1[4].Cost < costTest) /// Try Expansion
            {
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 0);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 1);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 2);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 3);
                ComputeCost1(3);// find cost0

                if (this.vArr1[3].Cost < this.vArr1[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    numOfOperations[1] += 4;
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                    numOfOperations[0] += 4;
                }

            }

            if (this.vArr1[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 3);
                ComputeCost1(4);  // contract to c1

                if (costTest < this.vArr1[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 3);
                    ComputeCost1(4);// find cost

                    if (this.vArr1[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                        numOfOperations[2] += 4;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; optimizeElementsInVertix[3] = "Element: does Contraction toward C1";
                    numOfOperations[3] += 4;
                }
            }

            if (this.vArr1[3].Cost >= costTest)
            {
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 0);
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 1);
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 2);
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 3);
                ComputeCost1(4);
                if (costTest <= this.vArr1[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 0);
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 1);
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 2);
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 3);
                    ComputeCost1(4);
                    if (this.vArr1[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                        numOfOperations[5] += 4;
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                    numOfOperations[4] += 4;
                }
            }
            this.vArr1[4].Cost = 0; this.vArr1[4].A = -3 + 3 * 0.1; this.vArr1[4].B = -1.05; this.vArr1[4].C = -3 + 3 * 0.1; this.vArr1[4].D = -1.05;
            ComputeCost1(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck2()
        {
            bool optimize = false;
            double costTest = this.vArr2[3].Cost;


            this.vArr2[4] = Vertix.TryRefluction(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 0); // 1. try reflection
            this.vArr2[4] = Vertix.TryRefluction(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 1);
            this.vArr2[4] = Vertix.TryRefluction(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 2);
            this.vArr2[4] = Vertix.TryRefluction(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 3);
            ComputeCost2(4);
            if (this.vArr2[4].Cost < costTest) /// Try Expansion
            {
                this.vArr2[3] = Vertix.TryExpansion(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], 0);
                this.vArr2[3] = Vertix.TryExpansion(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], 1);
                this.vArr2[3] = Vertix.TryExpansion(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], 2);
                this.vArr2[3] = Vertix.TryExpansion(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[3], 3);
                ComputeCost2(3);// find cost0

                if (this.vArr2[3].Cost < this.vArr2[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                }

            }

            if (this.vArr2[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr2[4] = Vertix.ContractToC1(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 0);
                this.vArr2[4] = Vertix.ContractToC1(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 1);
                this.vArr2[4] = Vertix.ContractToC1(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 2);
                this.vArr2[4] = Vertix.ContractToC1(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 3);
                ComputeCost2(4);  // contract to c1

                if (costTest < this.vArr2[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr2[4] = Vertix.ContractToC2(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 0);
                    this.vArr2[4] = Vertix.ContractToC2(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 1);
                    this.vArr2[4] = Vertix.ContractToC2(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 2);
                    this.vArr2[4] = Vertix.ContractToC2(this.vArr2[0], this.vArr2[1], this.vArr2[2], this.vArr2[4], 3);
                    ComputeCost2(4);// find cost

                    if (this.vArr2[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr2[3].Cost >= costTest)
            {
                this.vArr2[4] = Vertix.ShrinkGToB(this.vArr2[0], this.vArr2[1], this.vArr2[4], 0);
                this.vArr2[4] = Vertix.ShrinkGToB(this.vArr2[0], this.vArr2[1], this.vArr2[4], 1);
                this.vArr2[4] = Vertix.ShrinkGToB(this.vArr2[0], this.vArr2[1], this.vArr2[4], 2);
                this.vArr2[4] = Vertix.ShrinkGToB(this.vArr2[0], this.vArr2[1], this.vArr2[4], 3);
                ComputeCost2(4);
                if (costTest <= this.vArr2[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr2[4] = Vertix.ShrinkWToB(this.vArr2[2], this.vArr2[0], this.vArr2[4], 0);
                    this.vArr2[4] = Vertix.ShrinkWToB(this.vArr2[2], this.vArr2[0], this.vArr2[4], 1);
                    this.vArr2[4] = Vertix.ShrinkWToB(this.vArr2[2], this.vArr2[0], this.vArr2[4], 2);
                    this.vArr2[4] = Vertix.ShrinkWToB(this.vArr2[2], this.vArr2[0], this.vArr2[4], 3);
                    ComputeCost2(4);
                    if (this.vArr2[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr2[3] = (Vertix)this.vArr2[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                }
            }
            this.vArr2[4].Cost = 0; this.vArr2[4].A = -3; this.vArr2[4].B = -1; this.vArr2[4].C = -3; this.vArr2[4].D = -1;
            ComputeCost2(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck3()
        {
            bool optimize = false;
            double costTest = this.vArr3[3].Cost;


            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0); // 1. try reflection
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 3);
            ComputeCost3(4);
            if (this.vArr3[4].Cost < costTest) /// Try Expansion
            {
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 0);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 1);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 2);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 3);
                ComputeCost3(3);// find cost0

                if (this.vArr3[3].Cost < this.vArr3[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                }

            }

            if (this.vArr3[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 3);
                ComputeCost3(4);  // contract to c1

                if (costTest < this.vArr3[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 3);
                    ComputeCost3(4);// find cost

                    if (this.vArr3[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr3[3].Cost >= costTest)
            {
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 0);
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 1);
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 2);
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 3);
                ComputeCost3(4);
                if (costTest <= this.vArr3[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 0);
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 1);
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 2);
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 3);
                    ComputeCost3(4);
                    if (this.vArr3[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                }
            }
            this.vArr3[4].Cost = 0; this.vArr3[4].A = -3; this.vArr3[4].B = -0.95; this.vArr3[4].C = -3; this.vArr3[4].D = -0.95;
            ComputeCost3(4);
            return optimize;
        }
        public object Clone(int i)
        {
            Simplex snew = (Simplex)this.MemberwiseClone();
            snew.vArr[i] = (Vertix)this.vArr[i].Clone();
            return snew;
        }

        public override string ToString()
        {
            return "NofIteration =" + this.z[0].ToString() + "\nA " + optimizeElementsInVertix[0] + "\nB " + optimizeElementsInVertix[1] + "\nC " + optimizeElementsInVertix[2] + "\nD " +
                 optimizeElementsInVertix[3] + "\nBest1: " + "a: " + this.vArr[0].A.ToString() + "\tb: " + this.vArr[0].B.ToString() + "\tc: " + this.vArr[0].C.ToString() + "\td: " +
                 this.vArr[0].D.ToString() + "\tCost1: " + this.vArr[0].Cost.ToString() + "\nBest2: " + "a: " + this.vArr1[0].A.ToString() + "\tb: " + this.vArr1[0].B.ToString() +
                 "\tc: " + this.vArr1[0].C.ToString() + "\td: " + this.vArr1[0].D.ToString() + "\tCost2: " + this.vArr1[0].Cost.ToString() + "\tNofIteration =" + this.z[1].ToString() +
                 "\nBest3: " + "a: " + this.vArr2[0].A.ToString() + "\tb: " + this.vArr2[0].B.ToString() + "\tc: " + this.vArr2[0].C.ToString() + "\td: " + this.vArr2[0].D.ToString() +
                 "\tCost3: " + this.vArr2[0].Cost.ToString() + "\tNofIteration =" + this.z[2].ToString() + "\nBest4: " + "a: " + this.vArr3[0].A.ToString() + "\tb: " + 
                 this.vArr3[0].B.ToString() + "\tc: " + this.vArr3[0].C.ToString() + "\td: " + this.vArr3[0].D.ToString() + "\tCost4: " + this.vArr3[0].Cost.ToString() + 
                 "\tNofIteration =" + this.z[3].ToString();             

        }
    }
}