﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RosenBrockFunction
{
    class Simplex
    {          
        string whichIsBest;
        public string WhichIsBest
        {
            get { return whichIsBest; }
            set { whichIsBest = value; }
        }
      
        Vertix[] vArr = new Vertix[5]
        {
                new Vertix( 0.25, 0.39, 0.415, 0.39, 0),   
                new Vertix(0.25 + 0.25 * 0.05, 0.39 + 0.39 * 0.05, 0.415 + 0.415 * 0.05, 0.39 + 0.39 * 0.05, 0),  
                new Vertix(0.25 + 0.25 * 0.1, 0.39 + 0.39 * 0.1, 0.415 + 0.415 * 0.1, 0.39 + 0.39 * 0.1, 0),    
                new Vertix(0.25 + 0.25 * 0.1, 0.39 + 0.39 * 0.1, 0.415 + 0.415 * 0.1, 0.39 + 0.39 * 0.1, 0),   
                new Vertix(0.25 + 0.25 * 0.1, 0.39 + 0.39 * 0.1, 0.415 + 0.415 * 0.1, 0.39 + 0.39 * 0.1, 0),             
        };
        public Vertix[] VArr
        {
            get { return vArr; }
            set { vArr = value; }
        }
        Vertix[] vArr1 = new Vertix[5]
        {
                new Vertix(0.25, 0.39, 0.415, 0.39, 0),   
                new Vertix(0.25 - 0.25 * 0.05, 0.39, 0.415 - 0.415 * 0.05, 0.39, 0),  
                new Vertix(0.25 - 0.25 * 0.05, 0.39 + 0.39 * 0.05, 0.415 - 0.415 * 0.05, 0.39 + 0.39 * 0.05, 0),    
                new Vertix(0.25 - 0.25 * 0.1, 0.39 + 0.39 * 0.05, 0.415 - 0.415 * 0.1, 0.39 + 0.39 * 0.05, 0),   
                new Vertix(0.25 - 0.25 * 0.1, 0.39 + 0.39 * 0.1, 0.415 - 0.415 * 0.1, 0.39 + 0.39 * 0.1, 0),   
        };
        public Vertix[] VArr1
        {
            get { return vArr1; }
            set { vArr1 = value; }
        }
        Vertix[] vArr3 = new Vertix[5]
        {
                new Vertix(0.25, 0.39, 0.415, 0.39, 0),   
                new Vertix(0.25, 0.39 - 0.39 * 0.05, 0.415, 0.39 - 0.39 * 0.05, 0),  
                new Vertix(0.25 + 0.25 * 0.05, 0.39 - 0.39 * 0.05, 0.415 + 0.415 * 0.05, 0.39 - 0.39 * 0.05, 0),    
                new Vertix(0.25 + 0.25 * 0.05, 0.39 - 0.39 * 0.10, 0.415 + 0.415 * 0.05, 0.39 - 0.39 * 0.05, 0),   
                new Vertix(0.25 + 0.25 * 0.10, 0.39 - 0.39 * 0.10, 0.415 + 0.415 * 0.10, 0.39 - 0.39 * 0.10, 0),   
        };
        public Vertix[] VArr3
        {
            get { return vArr3; }
            set { vArr3 = value; }
        }
        Vertix[] vArr4 = new Vertix[5]
        {
                new Vertix(0.25, 0.39, 0.415, 0.39, 0),   
                new Vertix(0.25 - 0.25 * 0.05, 0.39 - 0.39 * 0.05, 0.415 - 0.415 * 0.05, 0.39 - 0.39 * 0.05, 0),  
                new Vertix(0.25 - 0.25 * 0.10, 0.39 - 0.39 * 0.10, 0.415 - 0.415 * 0.10, 0.39 - 0.39 * 0.10, 0),    
                new Vertix(0.25 - 0.25 * 0.15, 0.39 - 0.39 * 0.15, 0.415 - 0.415 * 0.15, 0.39 - 0.39 * 0.15, 0),   
                new Vertix(0.25 - 0.25 * 0.20, 0.39 - 0.39 * 0.20, 0.415 - 0.415 * 0.20, 0.39 - 0.39 * 0.20, 0),   
        };
        public Vertix[] VArr4
        {
            get { return vArr4; }
            set { vArr4 = value; }
        }
        double[] z = new double[5] { 0, 0, 0, 0, 0 };
        string[] optimizeElementsInVertix = new string[4]
        {
            "It did not optimize yet", "It did not optimize yet", "It did not optimize yet", "It did not optimize yet"
        };
        public string[] OptimizeElementsInVertix
        {
            get { return optimizeElementsInVertix; }
            set { optimizeElementsInVertix = value; }
        }
        public Simplex() {}

        public void ComputeCost(int i) //i=which cost  // X4=A, X3=B, X2=C, X1=D
        {

            this.vArr[i].Cost =  Math.Pow(0.1957 - ((this.vArr[i].A * (Math.Pow(4.0000, 2) + 4.0000 * this.vArr[i].B)) / (Math.Pow(4.0000, 2) + 4.0000 * this.vArr[i].C + this.vArr[i].D)), 2);
            this.vArr[i].Cost += Math.Pow(0.1947 - ((this.vArr[i].A * (Math.Pow(2.0000, 2) + 2.0000 * this.vArr[i].B)) / (Math.Pow(2.0000, 2) + 2.0000 * this.vArr[i].C + this.vArr[i].D)), 2);
            this.vArr[i].Cost += Math.Pow(0.1735 - ((this.vArr[i].A * (Math.Pow(1.0000, 2) + 1.0000 * this.vArr[i].B)) / (Math.Pow(1.0000, 2) + 1.0000 * this.vArr[i].C + this.vArr[i].D)), 2);
            this.vArr[i].Cost += Math.Pow(0.1600 - ((this.vArr[i].A * (Math.Pow(0.5000, 2) + 0.5000 * this.vArr[i].B)) / (Math.Pow(0.5000, 2) + 0.5000 * this.vArr[i].C + this.vArr[i].D)), 2);
            this.vArr[i].Cost += Math.Pow(0.0844 - ((this.vArr[i].A * (Math.Pow(0.2500, 2) + 0.2500 * this.vArr[i].B)) / (Math.Pow(0.2500, 2) + 0.2500 * this.vArr[i].C + this.vArr[i].D)), 2);
            this.vArr[i].Cost += Math.Pow(0.0627 - ((this.vArr[i].A * (Math.Pow(0.1670, 2) + 0.1670 * this.vArr[i].B)) / (Math.Pow(0.1670, 2) + 0.1670 * this.vArr[i].C + this.vArr[i].D)), 2);
            this.vArr[i].Cost += Math.Pow(0.0456 - ((this.vArr[i].A * (Math.Pow(0.1250, 2) + 0.1250 * this.vArr[i].B)) / (Math.Pow(0.1250, 2) + 0.1250 * this.vArr[i].C + this.vArr[i].D)), 2);
            this.vArr[i].Cost += Math.Pow(0.0342 - ((this.vArr[i].A * (Math.Pow(0.1000, 2) + 0.1000 * this.vArr[i].B)) / (Math.Pow(0.1000, 2) + 0.1000 * this.vArr[i].C + this.vArr[i].D)), 2);
            this.vArr[i].Cost += Math.Pow(0.0323 - ((this.vArr[i].A * (Math.Pow(0.0833, 2) + 0.0833 * this.vArr[i].B)) / (Math.Pow(0.0833, 2) + 0.0833 * this.vArr[i].C + this.vArr[i].D)), 2);
            this.vArr[i].Cost += Math.Pow(0.0235 - ((this.vArr[i].A * (Math.Pow(0.0714, 2) + 0.0714 * this.vArr[i].B)) / (Math.Pow(0.0714, 2) + 0.0714 * this.vArr[i].C + this.vArr[i].D)), 2);
            this.vArr[i].Cost += Math.Pow(0.0246 - ((this.vArr[i].A * (Math.Pow(0.0625, 2) + 0.0625 * this.vArr[i].B)) / (Math.Pow(0.0625, 2) + 0.0625 * this.vArr[i].C + this.vArr[i].D)), 2);
            z[0] += 1;
        }
        public void ComputeCost1(int i) //i=which cost  // X4=A, X3=B, X2=C, X1=D
        {

            this.vArr1[i].Cost = Math.Pow(0.1957 - ((this.vArr1[i].A * (Math.Pow(4.0000, 2) + 4.0000 * this.vArr1[i].B)) / (Math.Pow(4.0000, 2) + 4.0000 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            this.vArr1[i].Cost += Math.Pow(0.1947 - ((this.vArr1[i].A * (Math.Pow(2.0000, 2) + 2.0000 * this.vArr1[i].B)) / (Math.Pow(2.0000, 2) + 2.0000 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            this.vArr1[i].Cost += Math.Pow(0.1735 - ((this.vArr1[i].A * (Math.Pow(1.0000, 2) + 1.0000 * this.vArr1[i].B)) / (Math.Pow(1.0000, 2) + 1.0000 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            this.vArr1[i].Cost += Math.Pow(0.1600 - ((this.vArr1[i].A * (Math.Pow(0.5000, 2) + 0.5000 * this.vArr1[i].B)) / (Math.Pow(0.5000, 2) + 0.5000 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            this.vArr1[i].Cost += Math.Pow(0.0844 - ((this.vArr1[i].A * (Math.Pow(0.2500, 2) + 0.2500 * this.vArr1[i].B)) / (Math.Pow(0.2500, 2) + 0.2500 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            this.vArr1[i].Cost += Math.Pow(0.0627 - ((this.vArr1[i].A * (Math.Pow(0.1670, 2) + 0.1670 * this.vArr1[i].B)) / (Math.Pow(0.1670, 2) + 0.1670 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            this.vArr1[i].Cost += Math.Pow(0.0456 - ((this.vArr1[i].A * (Math.Pow(0.1250, 2) + 0.1250 * this.vArr1[i].B)) / (Math.Pow(0.1250, 2) + 0.1250 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            this.vArr1[i].Cost += Math.Pow(0.0342 - ((this.vArr1[i].A * (Math.Pow(0.1000, 2) + 0.1000 * this.vArr1[i].B)) / (Math.Pow(0.1000, 2) + 0.1000 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            this.vArr1[i].Cost += Math.Pow(0.0323 - ((this.vArr1[i].A * (Math.Pow(0.0833, 2) + 0.0833 * this.vArr1[i].B)) / (Math.Pow(0.0833, 2) + 0.0833 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            this.vArr1[i].Cost += Math.Pow(0.0235 - ((this.vArr1[i].A * (Math.Pow(0.0714, 2) + 0.0714 * this.vArr1[i].B)) / (Math.Pow(0.0714, 2) + 0.0714 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            this.vArr1[i].Cost += Math.Pow(0.0246 - ((this.vArr1[i].A * (Math.Pow(0.0625, 2) + 0.0625 * this.vArr1[i].B)) / (Math.Pow(0.0625, 2) + 0.0625 * this.vArr1[i].C + this.vArr1[i].D)), 2);
            z[1] += 1;
        }
        public void ComputeCost3(int i) //i=which cost  // X4=A, X3=B, X2=C, X1=D
        {

            this.vArr3[i].Cost = Math.Pow(0.1957 - ((this.vArr3[i].A * (Math.Pow(4.0000, 2) + 4.0000 * this.vArr3[i].B)) / (Math.Pow(4.0000, 2) + 4.0000 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            this.vArr3[i].Cost += Math.Pow(0.1947 - ((this.vArr3[i].A * (Math.Pow(2.0000, 2) + 2.0000 * this.vArr3[i].B)) / (Math.Pow(2.0000, 2) + 2.0000 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            this.vArr3[i].Cost += Math.Pow(0.1735 - ((this.vArr3[i].A * (Math.Pow(1.0000, 2) + 1.0000 * this.vArr3[i].B)) / (Math.Pow(1.0000, 2) + 1.0000 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            this.vArr3[i].Cost += Math.Pow(0.1600 - ((this.vArr3[i].A * (Math.Pow(0.5000, 2) + 0.5000 * this.vArr3[i].B)) / (Math.Pow(0.5000, 2) + 0.5000 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            this.vArr3[i].Cost += Math.Pow(0.0844 - ((this.vArr3[i].A * (Math.Pow(0.2500, 2) + 0.2500 * this.vArr3[i].B)) / (Math.Pow(0.2500, 2) + 0.2500 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            this.vArr3[i].Cost += Math.Pow(0.0627 - ((this.vArr3[i].A * (Math.Pow(0.1670, 2) + 0.1670 * this.vArr3[i].B)) / (Math.Pow(0.1670, 2) + 0.1670 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            this.vArr3[i].Cost += Math.Pow(0.0456 - ((this.vArr3[i].A * (Math.Pow(0.1250, 2) + 0.1250 * this.vArr3[i].B)) / (Math.Pow(0.1250, 2) + 0.1250 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            this.vArr3[i].Cost += Math.Pow(0.0342 - ((this.vArr3[i].A * (Math.Pow(0.1000, 2) + 0.1000 * this.vArr3[i].B)) / (Math.Pow(0.1000, 2) + 0.1000 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            this.vArr3[i].Cost += Math.Pow(0.0323 - ((this.vArr3[i].A * (Math.Pow(0.0833, 2) + 0.0833 * this.vArr3[i].B)) / (Math.Pow(0.0833, 2) + 0.0833 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            this.vArr3[i].Cost += Math.Pow(0.0235 - ((this.vArr3[i].A * (Math.Pow(0.0714, 2) + 0.0714 * this.vArr3[i].B)) / (Math.Pow(0.0714, 2) + 0.0714 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            this.vArr3[i].Cost += Math.Pow(0.0246 - ((this.vArr3[i].A * (Math.Pow(0.0625, 2) + 0.0625 * this.vArr3[i].B)) / (Math.Pow(0.0625, 2) + 0.0625 * this.vArr3[i].C + this.vArr3[i].D)), 2);
            z[3] += 1;
        }
        public void ComputeCost4(int i) //i=which cost  // X4=A, X3=B, X2=C, X1=D
        {

            this.vArr4[i].Cost = Math.Pow(0.1957 - ((this.vArr4[i].A * (Math.Pow(4.0000, 2) + 4.0000 * this.vArr4[i].B)) / (Math.Pow(4.0000, 2) + 4.0000 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            this.vArr4[i].Cost += Math.Pow(0.1947 - ((this.vArr4[i].A * (Math.Pow(2.0000, 2) + 2.0000 * this.vArr4[i].B)) / (Math.Pow(2.0000, 2) + 2.0000 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            this.vArr4[i].Cost += Math.Pow(0.1735 - ((this.vArr4[i].A * (Math.Pow(1.0000, 2) + 1.0000 * this.vArr4[i].B)) / (Math.Pow(1.0000, 2) + 1.0000 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            this.vArr4[i].Cost += Math.Pow(0.1600 - ((this.vArr4[i].A * (Math.Pow(0.5000, 2) + 0.5000 * this.vArr4[i].B)) / (Math.Pow(0.5000, 2) + 0.5000 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            this.vArr4[i].Cost += Math.Pow(0.0844 - ((this.vArr4[i].A * (Math.Pow(0.2500, 2) + 0.2500 * this.vArr4[i].B)) / (Math.Pow(0.2500, 2) + 0.2500 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            this.vArr4[i].Cost += Math.Pow(0.0627 - ((this.vArr4[i].A * (Math.Pow(0.1670, 2) + 0.1670 * this.vArr4[i].B)) / (Math.Pow(0.1670, 2) + 0.1670 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            this.vArr4[i].Cost += Math.Pow(0.0456 - ((this.vArr4[i].A * (Math.Pow(0.1250, 2) + 0.1250 * this.vArr4[i].B)) / (Math.Pow(0.1250, 2) + 0.1250 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            this.vArr4[i].Cost += Math.Pow(0.0342 - ((this.vArr4[i].A * (Math.Pow(0.1000, 2) + 0.1000 * this.vArr4[i].B)) / (Math.Pow(0.1000, 2) + 0.1000 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            this.vArr4[i].Cost += Math.Pow(0.0323 - ((this.vArr4[i].A * (Math.Pow(0.0833, 2) + 0.0833 * this.vArr4[i].B)) / (Math.Pow(0.0833, 2) + 0.0833 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            this.vArr4[i].Cost += Math.Pow(0.0235 - ((this.vArr4[i].A * (Math.Pow(0.0714, 2) + 0.0714 * this.vArr4[i].B)) / (Math.Pow(0.0714, 2) + 0.0714 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            this.vArr4[i].Cost += Math.Pow(0.0246 - ((this.vArr4[i].A * (Math.Pow(0.0625, 2) + 0.0625 * this.vArr4[i].B)) / (Math.Pow(0.0625, 2) + 0.0625 * this.vArr4[i].C + this.vArr4[i].D)), 2);
            z[4] += 1;
        }    
       

        public bool DoOptimizationOnVertixElements( int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr[3].Cost;
            this.vArr[4] = (Vertix)this.vArr[3].Clone(); // copy in case we cannot improve
            this.vArr[3] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost(3);

            if (this.vArr[3].Cost < costTest) /// Try Expansion
            {
                this.vArr[4] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                ComputeCost(4);// find cost0

                if (this.vArr[4].Cost < this.vArr[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";                   
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";                    
                }

            }

            if (this.vArr[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                 this.vArr[3] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                 ComputeCost(3);  // contract to c1

                 if (costTest <= this.vArr[3].Cost)   // Check c1
                 {
                     this.vArr[3] = (Vertix)this.vArr[4].Clone();
                     this.vArr[3] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                     ComputeCost(3);// find cost
                    
                     if  (this.vArr[3].Cost < costTest)  // c2 is better than c1
                     {
                         optimize = true;
                         optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";                         
                     }
                     else
                     {                         
                             this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                             optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";                          
                     }

                 }
                 else
                 {
                     optimize = true;  // C1 is better
                     optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                 }
            }

            if (this.vArr[3].Cost >= costTest)
            {
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                this.vArr[3] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[3], whichParameterOfVertix);
                ComputeCost(3);
                if (costTest <= this.vArr[3].Cost)    // Contract W to B
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr[3] = Vertix.ShrinkWToB(this.vArr[0], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                    ComputeCost(3);
                    if (this.vArr[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                }
            }
            
            this.vArr[4].Cost = 0; this.vArr[4].A = 0.25 + 0.25 * 0; this.vArr[4].B = 0.39 + 0.39 * 0; this.vArr[4].C = 0.415 + 0.415 * 0; this.vArr[4].D = 0.39 + 0.39 * 0; 
            ComputeCost(4);
            return optimize;
        }

        public bool DoOptimizationOnVertixElements1(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr1[3].Cost;
            this.vArr1[4] = (Vertix)this.vArr1[3].Clone(); // copy in case we cannot improve
            this.vArr1[3] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost1(3);

            if (this.vArr1[3].Cost < costTest) /// Try Expansion
            {
                this.vArr1[4] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(4);// find cost0

                if (this.vArr1[4].Cost < this.vArr1[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
            }

            if (this.vArr1[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                this.vArr1[3] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(3);  // contract to c1

                if (costTest <= this.vArr1[3].Cost)   // Check c1
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    this.vArr1[3] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                    ComputeCost1(3);// find cost

                    if (this.vArr1[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr1[3].Cost >= costTest)
            {
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                this.vArr1[3] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(3);
                if (costTest <= this.vArr1[3].Cost)    // Contract W to B
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    this.vArr1[3] = Vertix.ShrinkWToB(this.vArr1[0], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                    ComputeCost1(3);
                    if (this.vArr1[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                }
            }


            this.vArr1[4].Cost = 0; this.vArr1[4].A = 0.25 - 0.25 * 0.1; this.vArr1[4].B = 0.39 + 0.39 * 0.1; this.vArr1[4].C = 0.415 - 0.415 * 0.1; this.vArr1[4].D = 0.39 + 0.39 * 0.1;
            ComputeCost1(4);
            return optimize;
        }
        public bool DoOptimizationOnVertixElements3(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr3[3].Cost;
            this.vArr3[4] = (Vertix)this.vArr3[3].Clone(); // copy in case we cannot improve
            this.vArr3[3] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost3(3);

            if (this.vArr3[3].Cost < costTest) /// Try Expansion
            {
                this.vArr3[4] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(4);// find cost0

                if (this.vArr3[4].Cost < this.vArr3[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
            }

            if (this.vArr3[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                this.vArr3[3] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(3);  // contract to c1

                if (costTest <= this.vArr3[3].Cost)   // Check c1
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    this.vArr3[3] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                    ComputeCost3(3);// find cost

                    if (this.vArr3[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr3[3].Cost >= costTest)
            {
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                this.VArr3[3] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(3);
                if (costTest <= this.vArr3[3].Cost)    // Contract W to B
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    this.VArr3[3] = Vertix.ShrinkWToB(this.vArr3[0], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                    ComputeCost3(3);
                    if (this.vArr3[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                }
            }


            this.vArr3[4].Cost = 0; this.vArr3[4].A = 0.25; this.vArr3[4].B = 0.39; this.vArr3[4].C = 0.415; this.vArr3[4].D = 0.39;
            ComputeCost3(4);
            return optimize;
        }
        public bool DoOptimizationOnVertixElements4(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr4[3].Cost;
            this.vArr4[4] = (Vertix)this.vArr4[3].Clone(); // copy in case we cannot improve
            this.vArr4[3] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost4(3);

            if (this.vArr4[3].Cost < costTest) /// Try Expansion
            {
                this.vArr4[4] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(4);// find cost0

                if (this.vArr4[4].Cost < this.vArr4[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                }

            }
            else
            {
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
            }

            if (this.vArr4[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                this.vArr4[3] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(3);  // contract to c1

                if (costTest <= this.vArr4[3].Cost)   // Check c1
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    this.vArr4[3] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                    ComputeCost4(3);// find cost

                    if (this.vArr4[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr4[3].Cost >= costTest)
            {
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                this.VArr4[3] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(3);
                if (costTest <= this.vArr4[3].Cost)    // Contract W to B
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    this.VArr4[3] = Vertix.ShrinkWToB(this.vArr4[0], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                    ComputeCost4(3);
                    if (this.vArr4[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                }
            }
            this.vArr4[4].Cost = 0; this.vArr4[4].A = 0.25 - 0.25 * 0.15; this.vArr4[4].B = 0.39 - 0.39 * 0.15; this.vArr4[4].C = 0.415 - 0.415 * 0.15; this.vArr4[4].D = 0.39 - 0.39 * 0.15;
            ComputeCost4(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck()
        {
            bool optimize = false;
            double costTest = this.vArr[3].Cost;


            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0); // 1. try reflection
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 3);
            ComputeCost(4);
            if (this.vArr[4].Cost < costTest) /// Try Expansion
            {
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 0);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 1);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 2);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 3);
                ComputeCost(3);// find cost0

                if (this.vArr[3].Cost < this.vArr[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                }

            }

            if (this.vArr[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 3);
                ComputeCost(4);  // contract to c1

                if (costTest < this.vArr[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 3);
                    ComputeCost(4);// find cost

                    if (this.vArr[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; optimizeElementsInVertix[3] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr[3].Cost >= costTest)
            {
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 0);
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 1);
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 2);
                this.vArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 3);
                ComputeCost(4);
                if (costTest <= this.vArr[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 0);
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 1);
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 2);
                    this.vArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 3);
                    ComputeCost(4);
                    if (this.vArr[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                }
            }
            this.vArr[4].Cost = 0; this.vArr[4].A = 0.25 + 0.25 * 0; this.vArr[4].B = 0.39 + 0.39 * 0; this.vArr[4].C = 0.415 + 0.415 * 0; this.vArr[4].D = 0.39 + 0.39 * 0; 
            ComputeCost(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck1()
        {
            bool optimize = false;
            double costTest = this.vArr1[3].Cost;


            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0); // 1. try reflection
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 3);
            ComputeCost1(4);
            if (this.vArr1[4].Cost < costTest) /// Try Expansion
            {
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 0);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 1);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 2);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 3);
                ComputeCost1(3);// find cost0

                if (this.vArr1[3].Cost < this.vArr1[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                }

            }

            if (this.vArr1[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 3);
                ComputeCost1(4);  // contract to c1

                if (costTest < this.vArr1[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 3);
                    ComputeCost1(4);// find cost

                    if (this.vArr1[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; optimizeElementsInVertix[3] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr1[3].Cost >= costTest)
            {
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 0);
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 1);
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 2);
                this.vArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 3);
                ComputeCost1(4);
                if (costTest <= this.vArr1[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 0);
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 1);
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 2);
                    this.vArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 3);
                    ComputeCost1(4);
                    if (this.vArr1[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                }
            }
            this.vArr1[4].Cost = 0; this.vArr1[4].A = 0.25 - 0.25 * 0.1; this.vArr1[4].B = 0.39 + 0.39 * 0.1; this.vArr1[4].C = 0.415 - 0.415 * 0.1; this.vArr1[4].D = 0.39 + 0.39 * 0.1;
            ComputeCost1(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck3()
        {
            bool optimize = false;
            double costTest = this.vArr3[3].Cost;


            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0); // 1. try reflection
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 3);
            ComputeCost3(4);
            if (this.vArr3[4].Cost < costTest) /// Try Expansion
            {
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 0);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 1);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 2);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 3);
                ComputeCost3(3);// find cost0

                if (this.vArr3[3].Cost < this.vArr3[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                }

            }

            if (this.vArr3[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 3);
                ComputeCost3(4);  // contract to c1

                if (costTest < this.vArr3[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 3);
                    ComputeCost3(4);// find cost

                    if (this.vArr3[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr3[3].Cost >= costTest)
            {
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 0);
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 1);
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 2);
                this.vArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 3);
                ComputeCost3(4);
                if (costTest <= this.vArr3[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 0);
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 1);
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 2);
                    this.vArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 3);
                    ComputeCost3(4);
                    if (this.vArr3[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                }
            }
            this.vArr3[4].Cost = 0; this.vArr3[4].A = 0.25; this.vArr3[4].B = 0.39; this.vArr3[4].C = 0.415; this.vArr3[4].D = 0.39;
            ComputeCost3(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck4()
        {
            bool optimize = false;
            double costTest = this.vArr4[3].Cost;


            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0); // 1. try reflection
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 3);
            ComputeCost4(4);
            if (this.vArr4[4].Cost < costTest) /// Try Expansion
            {
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 0);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 1);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 2);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 3);
                ComputeCost4(3);// find cost0

                if (this.vArr4[3].Cost < this.vArr4[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                }

            }

            if (this.vArr4[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 3);
                ComputeCost4(4);  // contract to c1

                if (costTest < this.vArr4[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 3);
                    ComputeCost4(4);// find cost

                    if (this.vArr4[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }

                }
                else
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr4[3].Cost >= costTest)
            {
                this.vArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 0);
                this.vArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 1);
                this.vArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 2);
                this.vArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 3);
                ComputeCost4(4);
                if (costTest <= this.vArr4[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 0);
                    this.vArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 1);
                    this.vArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 2);
                    this.vArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 3);
                    ComputeCost4(4);
                    if (this.vArr4[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                    }
                }
                else
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                }
            }
            this.vArr4[4].Cost = 0; this.vArr4[4].A = 0.25 - 0.25 * 0.15; this.vArr4[4].B = 0.39 - 0.39 * 0.15; this.vArr4[4].C = 0.415 - 0.415 * 0.15; this.vArr4[4].D = 0.39 - 0.39 * 0.15;
            ComputeCost4(4);
            return optimize;
        }
        public object Clone(int i)
        {
            Simplex snew = (Simplex)this.MemberwiseClone();
            snew.vArr[i] = (Vertix)this.vArr[i].Clone();
            return snew;
        }

        public override string ToString()
        {
            return "NofIteration =" + this.z[0].ToString() + "\nA " + optimizeElementsInVertix[0] + "\nB " + optimizeElementsInVertix[1] + "\nC " + optimizeElementsInVertix[2] + "\nD " +
                 optimizeElementsInVertix[3] + "\nBest1: " + "a: " + this.vArr[0].A.ToString() + "\tb: " + this.vArr[0].B.ToString() + "\tCost1: " + this.vArr[0].Cost.ToString() +
                 "\nBest2: " + "a: " + this.vArr1[0].A.ToString() + "\tb: " + this.vArr1[0].B.ToString() + "\tCost2: " + this.vArr1[0].Cost.ToString() + "\tNofIteration =" +
                 this.z[1].ToString() + "\nBest4: " + "a: " + this.vArr3[0].A.ToString() + "\tb: " + this.vArr3[0].B.ToString() + "\tCost4: " + this.vArr3[0].Cost.ToString() +
                 "\tNofIteration =" + this.z[3].ToString() + "\nBest5: " + "a: " + this.vArr4[0].A.ToString() + "\tb: " + this.vArr4[0].B.ToString() + "\tCost5: " + 
                 this.vArr4[0].Cost.ToString() + "\tNofIteration =" + this.z[4].ToString();
        }
    }
}