﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RosenBrockFunction
{
    class Simplex
    {          
        string whichIsBest;
        public string WhichIsBest
        {
            get { return whichIsBest; }
            set { whichIsBest = value; }
        }
      
        Vertix[] vArr = new Vertix[5]
        {
                new Vertix(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0),   
                new Vertix(1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 1.05, 0), 
                new Vertix(1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 0),    
                new Vertix(1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 0), 
                new Vertix(1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 1.1, 0),   
        };
        public Vertix[] VArr
        {
            get { return vArr; }
            set { vArr = value; }
        }

        Vertix[] vArr1 = new Vertix[5]
        {
                new Vertix(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0),   
                new Vertix(0.95, 1, 0.95, 1, 0.95, 1, 0.95, 1, 0.95, 1, 0.95, 1, 0.95, 1, 0.95, 1, 0), 
                new Vertix(0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0),    
                new Vertix(0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0), 
                new Vertix(0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0),   
        };
        public Vertix[] VArr1
        {
            get { return vArr1; }
            set { vArr1 = value; }
        }

        Vertix[] vArr3 = new Vertix[5]
        {
                new Vertix(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0),   
                new Vertix(1, 0.95, 1, 0.95, 1, 0.95, 1, 0.95, 1, 0.95, 1, 0.95, 1, 0.95, 1, 0.95, 0), 
                new Vertix(1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 1.05, 0.95, 0),    
                new Vertix(1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 1.05, 0.9, 0), 
                new Vertix(1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 1.1, 0.9, 0),   
        };
        public Vertix[] VArr3
        {
            get { return vArr3; }
            set { vArr3 = value; }
        }

        Vertix[] vArr4 = new Vertix[5]
        {
                new Vertix(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0),   
                new Vertix(0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0.95, 0), 
                new Vertix(0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0),    
                new Vertix(0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0.85, 0), 
                new Vertix(0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0.8, 0),   
        };
        public Vertix[] VArr4
        {
            get { return vArr4; }
            set { vArr4 = value; }
        }

        double[] z = new double[5] { 0, 0, 0, 0, 0 };

        string[] optimizeElementsInVertix = new string[16]
        {
            "It did not optimize yet", "It did not optimize yet", "It did not optimize yet", "It did not optimize yet", "It did not optimize yet", 
            "It did not optimize yet", "It did not optimize yet", "It did not optimize yet", "It did not optimize yet", "It did not optimize yet",
             "It did not optimize yet",
            "It did not optimize yet", "It did not optimize yet", "It did not optimize yet", "It did not optimize yet", "It did not optimize yet"  
        };
        public string[] OptimizeElementsInVertix
        {
            get { return optimizeElementsInVertix; }
            set { optimizeElementsInVertix = value; }
        }
        public Simplex() {}                     
        
        public void ComputeCost( int i) //i=which cost
        {

            this.vArr[i].Cost = Math.Pow(this.vArr[i].X1, 2) + Math.Pow(this.vArr[i].X2, 2) + Math.Pow(this.vArr[i].X3, 2) +
                Math.Pow(this.vArr[i].X4, 2) + Math.Pow(this.vArr[i].X5, 2) + Math.Pow(this.vArr[i].X6, 2) + Math.Pow(this.vArr[i].X7, 2) +
                Math.Pow(this.vArr[i].X8, 2) + Math.Pow(this.vArr[i].X9, 2) + Math.Pow(this.vArr[i].X10, 2) + Math.Pow(this.vArr[i].X11, 2) +
                Math.Pow(this.vArr[i].X12, 2) + Math.Pow(this.vArr[i].X13, 2) + Math.Pow(this.vArr[i].X14, 2) + Math.Pow(this.vArr[i].X15, 2) +
                Math.Pow(this.vArr[i].X16, 2);
            z[0] += 1;
        }

        public void ComputeCost1(int i) //i=which cost
        {

            this.vArr1[i].Cost = Math.Pow(this.vArr1[i].X1, 2) + Math.Pow(this.vArr1[i].X2, 2) + Math.Pow(this.vArr1[i].X3, 2) +
                Math.Pow(this.vArr1[i].X4, 2) + Math.Pow(this.vArr1[i].X5, 2) + Math.Pow(this.vArr1[i].X6, 2) + Math.Pow(this.vArr1[i].X7, 2) +
                Math.Pow(this.vArr1[i].X8, 2) + Math.Pow(this.vArr1[i].X9, 2) + Math.Pow(this.vArr1[i].X10, 2) + Math.Pow(this.vArr1[i].X11, 2) +
                Math.Pow(this.vArr1[i].X12, 2) + Math.Pow(this.vArr1[i].X13, 2) + Math.Pow(this.vArr1[i].X14, 2) + Math.Pow(this.vArr1[i].X15, 2) +
                Math.Pow(this.vArr1[i].X16, 2);
            z[1] += 1;
        }

        public void ComputeCost3(int i) //i=which cost
        {

            this.vArr3[i].Cost = Math.Pow(this.vArr3[i].X1, 2) + Math.Pow(this.vArr3[i].X2, 2) + Math.Pow(this.vArr3[i].X3, 2) +
                Math.Pow(this.vArr3[i].X4, 2) + Math.Pow(this.vArr3[i].X5, 2) + Math.Pow(this.vArr3[i].X6, 2) + Math.Pow(this.vArr3[i].X7, 2) +
                Math.Pow(this.vArr3[i].X8, 2) + Math.Pow(this.vArr3[i].X9, 2) + Math.Pow(this.vArr3[i].X10, 2) + Math.Pow(this.vArr3[i].X11, 2) +
                Math.Pow(this.vArr3[i].X12, 2) + Math.Pow(this.vArr3[i].X13, 2) + Math.Pow(this.vArr3[i].X14, 2) + Math.Pow(this.vArr3[i].X15, 2) +
                Math.Pow(this.vArr3[i].X16, 2);
            z[3] += 1;
        }

        public void ComputeCost4(int i) //i=which cost
        {

            this.vArr4[i].Cost = Math.Pow(this.vArr4[i].X1, 2) + Math.Pow(this.vArr4[i].X2, 2) + Math.Pow(this.vArr4[i].X3, 2) +
                Math.Pow(this.vArr4[i].X4, 2) + Math.Pow(this.vArr4[i].X5, 2) + Math.Pow(this.vArr4[i].X6, 2) + Math.Pow(this.vArr4[i].X7, 2) +
                Math.Pow(this.vArr4[i].X8, 2) + Math.Pow(this.vArr4[i].X9, 2) + Math.Pow(this.vArr4[i].X10, 2) + Math.Pow(this.vArr4[i].X11, 2) +
                Math.Pow(this.vArr4[i].X12, 2) + Math.Pow(this.vArr4[i].X13, 2) + Math.Pow(this.vArr4[i].X14, 2) + Math.Pow(this.vArr4[i].X15, 2) +
                Math.Pow(this.vArr4[i].X16, 2);
            z[4] += 1;
        } 
        public bool DoOptimizationOnVertixElements( int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr[3].Cost;
            this.vArr[4] = (Vertix)this.vArr[3].Clone(); // copy in case we cannot improve
            this.vArr[3] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost(3);

            if (this.vArr[3].Cost < costTest) /// Try Expansion
            {
                this.vArr[4] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                ComputeCost(4);// find cost0

                if (this.vArr[4].Cost < this.vArr[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";                   
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";                    
                }

            }
            else
            {
                optimize = false;
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
            }

            if (this.vArr[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                 this.vArr[3] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                 ComputeCost(3);  // contract to c1

                 if (costTest <= this.vArr[3].Cost)   // Check c1
                 {
                     this.vArr[3] = (Vertix)this.vArr[4].Clone();
                     this.vArr[3] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                     ComputeCost(3);// find cost
                    
                     if  (this.vArr[3].Cost < costTest)  // c2 is better than c1
                     {
                         optimize = true;
                         optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";                         
                     }
                     else
                     {                         
                             this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                             optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";                          
                     }

                 }
                 else
                 {
                     optimize = true;  // C1 is better
                     optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                 }
            }

            if (this.vArr[3].Cost >= costTest)
            {
                this.vArr[3] = (Vertix)this.vArr[4].Clone();
                this.VArr[3] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[3], whichParameterOfVertix);
                ComputeCost(3);
                if (costTest <= this.vArr[3].Cost)    // Contract W to B
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr[3] = Vertix.ShrinkWToB(this.vArr[0], this.vArr[2], this.vArr[3], whichParameterOfVertix);
                    ComputeCost(3);
                    if (this.vArr[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                }
            }


            this.vArr[4].Cost = 0; 
            this.vArr[4].X1 = 1; this.vArr[4].X2 = 1; this.vArr[4].X3 = 1; this.vArr[4].X4 = 1; this.vArr[4].X5 = 1;
            this.vArr[4].X6 = 1; this.vArr[4].X7 = 1; this.vArr[4].X8 = 1; this.vArr[4].X9 = 1; this.vArr[4].X10 = 1; this.vArr[4].X11 = 1;
            this.vArr[4].X12 = 1; this.vArr[4].X13 = 1; this.vArr[4].X14 = 1; this.vArr[4].X15 = 1; this.vArr[4].X16 = 1; 
            ComputeCost(4);
            return optimize;
        }

        public bool DoOptimizationOnVertixElements1(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr1[3].Cost;
            this.vArr1[4] = (Vertix)this.vArr1[3].Clone(); // copy in case we cannot improve
            this.vArr1[3] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost1(3);

            if (this.vArr1[3].Cost < costTest) /// Try Expansion
            {
                this.vArr1[4] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(4);// find cost0

                if (this.vArr1[4].Cost < this.vArr1[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                }

            }
            else
            {
                optimize = false;
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
            }

            if (this.vArr1[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                this.vArr1[3] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(3);  // contract to c1

                if (costTest <= this.vArr1[3].Cost)   // Check c1
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    this.vArr1[3] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                    ComputeCost1(3);// find cost

                    if (this.vArr1[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr1[3].Cost >= costTest)
            {
                this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                this.VArr1[3] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[3], whichParameterOfVertix);
                ComputeCost1(3);
                if (costTest <= this.vArr1[3].Cost)    // Contract W to B
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    this.VArr1[3] = Vertix.ShrinkWToB(this.vArr1[0], this.vArr1[2], this.vArr1[3], whichParameterOfVertix);
                    ComputeCost1(3);
                    if (this.vArr1[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                }
            }


            this.vArr1[4].Cost = 0;
            this.vArr1[4].X1 = 0.9; this.vArr1[4].X2 = 1.1; this.vArr1[4].X3 = 0.9; this.vArr1[4].X4 = 1.1; this.vArr1[4].X5 = 0.9; this.vArr1[4].X6 = 1.1; this.vArr1[4].X7 = 0.9;
            this.vArr1[4].X8 = 1.1; this.vArr1[4].X9 = 0.9; this.vArr1[4].X10 = 1.1; this.vArr1[4].X11 = 0.9; this.vArr1[4].X12 = 1.1; this.vArr1[4].X13 = 0.9; this.vArr1[4].X14 = 1.1;
            this.vArr1[4].X15 = 0.9; this.vArr1[4].X16 = 1.1;
            ComputeCost1(4);
            return optimize;
        }

        public bool DoOptimizationOnVertixElements3(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr3[3].Cost;
            this.vArr3[4] = (Vertix)this.vArr3[3].Clone(); // copy in case we cannot improve
            this.vArr3[3] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost3(3);

            if (this.vArr3[3].Cost < costTest) /// Try Expansion
            {
                this.vArr3[4] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(4);// find cost0

                if (this.vArr3[4].Cost < this.vArr3[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                }

            }
            else
            {
                optimize = false;
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
            }

            if (this.vArr3[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                this.vArr3[3] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(3);  // contract to c1

                if (costTest <= this.vArr3[3].Cost)   // Check c1
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    this.vArr3[3] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                    ComputeCost3(3);// find cost

                    if (this.vArr3[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr3[3].Cost >= costTest)
            {
                this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                this.VArr3[3] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[3], whichParameterOfVertix);
                ComputeCost3(3);
                if (costTest <= this.vArr3[3].Cost)    // Contract W to B
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    this.VArr3[3] = Vertix.ShrinkWToB(this.vArr3[0], this.vArr3[2], this.vArr3[3], whichParameterOfVertix);
                    ComputeCost3(3);
                    if (this.vArr3[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                }
            }


            this.vArr3[4].Cost = 0;
            this.vArr3[4].X1 = 1.1; this.vArr3[4].X2 = 0.9; this.vArr3[4].X3 = 1.1; this.vArr3[4].X4 = 0.9; this.vArr3[4].X5 = 1.1; this.vArr3[4].X6 = 0.9; this.vArr3[4].X7 = 1.1;
            this.vArr3[4].X8 = 0.9; this.vArr3[4].X9 = 1.1; this.vArr3[4].X10 = 0.9; this.vArr3[4].X11 = 1.1; this.vArr3[4].X12 = 0.9; this.vArr3[4].X13 = 1.1; this.vArr3[4].X14 = 0.9;
            this.vArr3[4].X15 = 1.1; this.vArr3[4].X16 = 0.9;
            ComputeCost3(4);
            return optimize;
        }

        public bool DoOptimizationOnVertixElements4(int whichParameterOfVertix)
        {
            bool optimize = false;
            double costTest = this.vArr4[3].Cost;
            this.vArr4[4] = (Vertix)this.vArr4[3].Clone(); // copy in case we cannot improve
            this.vArr4[3] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix); // 1. try reflection
            ComputeCost4(3);

            if (this.vArr4[3].Cost < costTest) /// Try Expansion
            {
                this.vArr4[4] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(4);// find cost0

                if (this.vArr4[4].Cost < this.vArr4[3].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Expansion";
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();

                }
                else
                {
                    optimize = true;
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Reflection";
                }

            }
            else
            {
                optimize = false;
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
            }

            if (this.vArr4[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                this.vArr4[3] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(3);  // contract to c1

                if (costTest <= this.vArr4[3].Cost)   // Check c1
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    this.vArr4[3] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                    ComputeCost4(3);// find cost

                    if (this.vArr4[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C2";
                    }
                    else
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }

                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Contraction toward C1";
                }
            }

            if (this.vArr4[3].Cost >= costTest)
            {
                this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                this.VArr4[3] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[3], whichParameterOfVertix);
                ComputeCost4(3);
                if (costTest <= this.vArr4[3].Cost)    // Contract W to B
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    this.VArr4[3] = Vertix.ShrinkWToB(this.vArr4[0], this.vArr4[2], this.vArr4[3], whichParameterOfVertix);
                    ComputeCost4(3);
                    if (this.vArr4[3].Cost < costTest)  // c2 is better than c1
                    {
                        optimize = true;
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Worse to Best";
                    }
                    else
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[whichParameterOfVertix] = "Element: does nothing";
                    }
                }
                else
                {
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[whichParameterOfVertix] = "Element: does Shrink Good to Best";
                }
            }


            this.vArr4[4].Cost = 0;
            this.vArr4[4].X1 = 1; this.vArr4[4].X2 = 1; this.vArr4[4].X3 = 1; this.vArr4[4].X4 = 1; this.vArr4[4].X5 = 1; this.vArr4[4].X6 = 1; this.vArr4[4].X7 = 1;
            this.vArr4[4].X8 = 1; this.vArr4[4].X9 = 1; this.vArr4[4].X10 = 1; this.vArr4[4].X11 = 1; this.vArr4[4].X12 = 1; this.vArr4[4].X13 = 1; this.vArr4[4].X14 = 1;
            this.vArr4[4].X15 = 1; this.vArr4[4].X16 = 1;
            ComputeCost4(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck()
        {
            bool optimize = false;
            double costTest = this.vArr[3].Cost;


            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0); // 1. try reflection
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 3);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 4);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 5);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 6);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 7);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 8);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 9);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 10);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 11);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 12);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 13);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 14);
            this.vArr[4] = Vertix.TryRefluction(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 15);
            
            ComputeCost(4);
            if (this.vArr[4].Cost < costTest) /// Try Expansion
            {
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 0);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 1);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 2);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 3);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 4);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 5);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 6);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 7);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 8);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 9);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 10);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 11);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 12);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 13);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 14);
                this.vArr[3] = Vertix.TryExpansion(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[3], 15);
                
                ComputeCost(3);// find cost0

                if (this.vArr[3].Cost < this.vArr[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    optimizeElementsInVertix[4] = "Element: does Expansion"; optimizeElementsInVertix[5] = "Element: does Expansion";
                    optimizeElementsInVertix[6] = "Element: does Expansion"; optimizeElementsInVertix[7] = "Element: does Expansion";
                    optimizeElementsInVertix[8] = "Element: does Expansion"; optimizeElementsInVertix[9] = "Element: does Expansion";
                    optimizeElementsInVertix[10] = "Element: does Expansion"; optimizeElementsInVertix[11] = "Element: does Expansion";
                    optimizeElementsInVertix[12] = "Element: does Expansion"; optimizeElementsInVertix[13] = "Element: does Expansion";
                    optimizeElementsInVertix[14] = "Element: does Expansion"; optimizeElementsInVertix[15] = "Element: does Expansion";
                    
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                    optimizeElementsInVertix[4] = "Element: does Reflection"; optimizeElementsInVertix[5] = "Element: does Reflection";
                    optimizeElementsInVertix[6] = "Element: does Reflection"; optimizeElementsInVertix[7] = "Element: does Reflection";
                    optimizeElementsInVertix[8] = "Element: does Reflection"; optimizeElementsInVertix[9] = "Element: does Reflection";
                    optimizeElementsInVertix[10] = "Element: does Reflection"; optimizeElementsInVertix[11] = "Element: does Reflection";
                    optimizeElementsInVertix[12] = "Element: does Reflection"; optimizeElementsInVertix[13] = "Element: does Reflection";
                    optimizeElementsInVertix[14] = "Element: does Reflection"; optimizeElementsInVertix[15] = "Element: does Reflection";
                    
                }

            }

            if (this.vArr[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 3);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 4);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 5);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 6);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 7);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 8);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 9);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 10);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 11);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 12);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 13);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 14);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 15);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 16);
                this.vArr[4] = Vertix.ContractToC1(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 17);
                
                ComputeCost(4);  // contract to c1

                if (costTest < this.vArr[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 0);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 1);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 2);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 3);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 4);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 5);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 6);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 7);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 8);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 9);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 10);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 11);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 12);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 13);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 14);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 15);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 16);
                    this.vArr[4] = Vertix.ContractToC2(this.vArr[0], this.vArr[1], this.vArr[2], this.vArr[4], 17);
                    
                    ComputeCost(4);// find cost

                    if (this.vArr[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[4] = "Element: does Contraction toward C2"; optimizeElementsInVertix[5] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[6] = "Element: does Contraction toward C2"; optimizeElementsInVertix[7] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[8] = "Element: does Contraction toward C2"; optimizeElementsInVertix[9] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[10] = "Element: does Contraction toward C2"; optimizeElementsInVertix[11] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[12] = "Element: does Contraction toward C2"; optimizeElementsInVertix[13] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[14] = "Element: does Contraction toward C2"; optimizeElementsInVertix[15] = "Element: does Contraction toward C2";
                        
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                        optimizeElementsInVertix[4] = "Element: does nothing"; optimizeElementsInVertix[5] = "Element: does nothing";
                        optimizeElementsInVertix[6] = "Element: does nothing"; optimizeElementsInVertix[7] = "Element: does nothing";
                        optimizeElementsInVertix[8] = "Element: does nothing"; optimizeElementsInVertix[9] = "Element: does nothing";
                        optimizeElementsInVertix[10] = "Element: does nothing"; optimizeElementsInVertix[11] = "Element: does nothing";
                        optimizeElementsInVertix[12] = "Element: does nothing"; optimizeElementsInVertix[13] = "Element: does nothing";
                        optimizeElementsInVertix[14] = "Element: does nothing"; optimizeElementsInVertix[15] = "Element: does nothing";
                        
                    }

                }
                else
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; optimizeElementsInVertix[3] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[4] = "Element: does Contraction toward C1"; optimizeElementsInVertix[5] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[6] = "Element: does Contraction toward C1"; optimizeElementsInVertix[7] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[8] = "Element: does Contraction toward C1"; optimizeElementsInVertix[9] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[10] = "Element: does Contraction toward C1"; optimizeElementsInVertix[11] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[12] = "Element: does Contraction toward C1"; optimizeElementsInVertix[13] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[14] = "Element: does Contraction toward C1"; optimizeElementsInVertix[15] = "Element: does Contraction toward C1";
                    
                }
            }

            if (this.vArr[3].Cost >= costTest)
            {
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 0);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 1);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 2);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 3);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 4);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 5);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 6);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 7);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 8);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 9);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 10);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 11);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 12);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 13);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 14);
                this.VArr[4] = Vertix.ShrinkGToB(this.vArr[0], this.vArr[1], this.vArr[4], 15);
                
                ComputeCost(4);
                if (costTest <= this.vArr[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 0);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 1);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 2);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 3);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 4);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 5);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 6);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 7);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 8);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 9);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 10);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 11);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 12);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 13);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 14);
                    this.VArr[4] = Vertix.ShrinkWToB(this.vArr[2], this.vArr[0], this.vArr[4], 15);
                    
                    ComputeCost(4);
                    if (this.vArr[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr[3] = (Vertix)this.vArr[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[4] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[5] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[6] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[7] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[8] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[9] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[10] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[11] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[12] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[13] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[14] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[15] = "Element: does Shrink Worse to Best";
                        
                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                        optimizeElementsInVertix[4] = "Element: does nothing"; optimizeElementsInVertix[5] = "Element: does nothing";
                        optimizeElementsInVertix[6] = "Element: does nothing"; optimizeElementsInVertix[7] = "Element: does nothing";
                        optimizeElementsInVertix[8] = "Element: does nothing"; optimizeElementsInVertix[9] = "Element: does nothing";
                        optimizeElementsInVertix[10] = "Element: does nothing"; optimizeElementsInVertix[11] = "Element: does nothing";
                        optimizeElementsInVertix[12] = "Element: does nothing"; optimizeElementsInVertix[13] = "Element: does nothing";
                        optimizeElementsInVertix[14] = "Element: does nothing"; optimizeElementsInVertix[15] = "Element: does nothing";
                        
                    }
                }
                else
                {
                    this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[4] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[5] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[6] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[7] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[8] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[9] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[10] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[11] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[12] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[13] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[14] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[15] = "Element: does Shrink Good to Best";
                    
                }
            }
            this.vArr[4].Cost = 0; 
            this.vArr[4].X1 = 1; this.vArr[4].X2 = 1; this.vArr[4].X3 = 1; this.vArr[4].X4 = 1; this.vArr[4].X5 = 1;
            this.vArr[4].X6 = 1; this.vArr[4].X7 = 1; this.vArr[4].X8 = 1; this.vArr[4].X9 = 1; this.vArr[4].X10 = 1; this.vArr[4].X11 = 1;
            this.vArr[4].X12 = 1; this.vArr[4].X13 = 1; this.vArr[4].X14 = 1; this.vArr[4].X15 = 1; this.vArr[4].X16 = 1; 
            ComputeCost(4);
            return optimize;
        }
        public bool DoOptimizationWheenThStuck1()
        {
            bool optimize = false;
            double costTest = this.vArr1[3].Cost;


            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0); // 1. try reflection
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 3);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 4);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 5);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 6);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 7);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 8);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 9);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 10);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 11);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 12);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 13);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 14);
            this.vArr1[4] = Vertix.TryRefluction(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 15);

            ComputeCost1(4);
            if (this.vArr1[4].Cost < costTest) /// Try Expansion
            {
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 0);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 1);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 2);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 3);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 4);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 5);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 6);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 7);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 8);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 9);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 10);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 11);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 12);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 13);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 14);
                this.vArr1[3] = Vertix.TryExpansion(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[3], 15);

                ComputeCost1(3);// find cost0

                if (this.vArr1[3].Cost < this.vArr1[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    optimizeElementsInVertix[4] = "Element: does Expansion"; optimizeElementsInVertix[5] = "Element: does Expansion";
                    optimizeElementsInVertix[6] = "Element: does Expansion"; optimizeElementsInVertix[7] = "Element: does Expansion";
                    optimizeElementsInVertix[8] = "Element: does Expansion"; optimizeElementsInVertix[9] = "Element: does Expansion";
                    optimizeElementsInVertix[10] = "Element: does Expansion"; optimizeElementsInVertix[11] = "Element: does Expansion";
                    optimizeElementsInVertix[12] = "Element: does Expansion"; optimizeElementsInVertix[13] = "Element: does Expansion";
                    optimizeElementsInVertix[14] = "Element: does Expansion"; optimizeElementsInVertix[15] = "Element: does Expansion";

                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                    optimizeElementsInVertix[4] = "Element: does Reflection"; optimizeElementsInVertix[5] = "Element: does Reflection";
                    optimizeElementsInVertix[6] = "Element: does Reflection"; optimizeElementsInVertix[7] = "Element: does Reflection";
                    optimizeElementsInVertix[8] = "Element: does Reflection"; optimizeElementsInVertix[9] = "Element: does Reflection";
                    optimizeElementsInVertix[10] = "Element: does Reflection"; optimizeElementsInVertix[11] = "Element: does Reflection";
                    optimizeElementsInVertix[12] = "Element: does Reflection"; optimizeElementsInVertix[13] = "Element: does Reflection";
                    optimizeElementsInVertix[14] = "Element: does Reflection"; optimizeElementsInVertix[15] = "Element: does Reflection";

                }

            }

            if (this.vArr1[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 3);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 4);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 5);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 6);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 7);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 8);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 9);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 10);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 11);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 12);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 13);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 14);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 15);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 16);
                this.vArr1[4] = Vertix.ContractToC1(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 17);

                ComputeCost1(4);  // contract to c1

                if (costTest < this.vArr1[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 0);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 1);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 2);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 3);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 4);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 5);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 6);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 7);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 8);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 9);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 10);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 11);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 12);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 13);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 14);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 15);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 16);
                    this.vArr1[4] = Vertix.ContractToC2(this.vArr1[0], this.vArr1[1], this.vArr1[2], this.vArr1[4], 17);

                    ComputeCost1(4);// find cost

                    if (this.vArr1[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[4] = "Element: does Contraction toward C2"; optimizeElementsInVertix[5] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[6] = "Element: does Contraction toward C2"; optimizeElementsInVertix[7] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[8] = "Element: does Contraction toward C2"; optimizeElementsInVertix[9] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[10] = "Element: does Contraction toward C2"; optimizeElementsInVertix[11] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[12] = "Element: does Contraction toward C2"; optimizeElementsInVertix[13] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[14] = "Element: does Contraction toward C2"; optimizeElementsInVertix[15] = "Element: does Contraction toward C2";

                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                        optimizeElementsInVertix[4] = "Element: does nothing"; optimizeElementsInVertix[5] = "Element: does nothing";
                        optimizeElementsInVertix[6] = "Element: does nothing"; optimizeElementsInVertix[7] = "Element: does nothing";
                        optimizeElementsInVertix[8] = "Element: does nothing"; optimizeElementsInVertix[9] = "Element: does nothing";
                        optimizeElementsInVertix[10] = "Element: does nothing"; optimizeElementsInVertix[11] = "Element: does nothing";
                        optimizeElementsInVertix[12] = "Element: does nothing"; optimizeElementsInVertix[13] = "Element: does nothing";
                        optimizeElementsInVertix[14] = "Element: does nothing"; optimizeElementsInVertix[15] = "Element: does nothing";

                    }

                }
                else
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; optimizeElementsInVertix[3] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[4] = "Element: does Contraction toward C1"; optimizeElementsInVertix[5] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[6] = "Element: does Contraction toward C1"; optimizeElementsInVertix[7] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[8] = "Element: does Contraction toward C1"; optimizeElementsInVertix[9] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[10] = "Element: does Contraction toward C1"; optimizeElementsInVertix[11] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[12] = "Element: does Contraction toward C1"; optimizeElementsInVertix[13] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[14] = "Element: does Contraction toward C1"; optimizeElementsInVertix[15] = "Element: does Contraction toward C1";

                }
            }

            if (this.vArr1[3].Cost >= costTest)
            {
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 0);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 1);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 2);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 3);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 4);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 5);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 6);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 7);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 8);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 9);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 10);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 11);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 12);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 13);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 14);
                this.VArr1[4] = Vertix.ShrinkGToB(this.vArr1[0], this.vArr1[1], this.vArr1[4], 15);

                ComputeCost1(4);
                if (costTest <= this.vArr1[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 0);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 1);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 2);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 3);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 4);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 5);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 6);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 7);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 8);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 9);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 10);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 11);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 12);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 13);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 14);
                    this.VArr1[4] = Vertix.ShrinkWToB(this.vArr1[2], this.vArr1[0], this.vArr1[4], 15);

                    ComputeCost1(4);
                    if (this.vArr1[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[4] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[5] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[6] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[7] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[8] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[9] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[10] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[11] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[12] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[13] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[14] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[15] = "Element: does Shrink Worse to Best";

                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                        optimizeElementsInVertix[4] = "Element: does nothing"; optimizeElementsInVertix[5] = "Element: does nothing";
                        optimizeElementsInVertix[6] = "Element: does nothing"; optimizeElementsInVertix[7] = "Element: does nothing";
                        optimizeElementsInVertix[8] = "Element: does nothing"; optimizeElementsInVertix[9] = "Element: does nothing";
                        optimizeElementsInVertix[10] = "Element: does nothing"; optimizeElementsInVertix[11] = "Element: does nothing";
                        optimizeElementsInVertix[12] = "Element: does nothing"; optimizeElementsInVertix[13] = "Element: does nothing";
                        optimizeElementsInVertix[14] = "Element: does nothing"; optimizeElementsInVertix[15] = "Element: does nothing";

                    }
                }
                else
                {
                    this.vArr1[3] = (Vertix)this.vArr1[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[4] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[5] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[6] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[7] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[8] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[9] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[10] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[11] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[12] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[13] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[14] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[15] = "Element: does Shrink Good to Best";

                }
            }
            this.vArr1[4].Cost = 0;
            this.vArr1[4].X1 = 0.9; this.vArr1[4].X2 = 1.1; this.vArr1[4].X3 = 0.9; this.vArr1[4].X4 = 1.1; this.vArr1[4].X5 = 0.9; this.vArr1[4].X6 = 1.1; this.vArr1[4].X7 = 0.9;
            this.vArr1[4].X8 = 1.1; this.vArr1[4].X9 = 0.9; this.vArr1[4].X10 = 1.1; this.vArr1[4].X11 = 0.9; this.vArr1[4].X12 = 1.1; this.vArr1[4].X13 = 0.9; this.vArr1[4].X14 = 1.1;
            this.vArr1[4].X15 = 0.9; this.vArr1[4].X16 = 1.1;
            ComputeCost1(4);
            return optimize;
        }

        public bool DoOptimizationWheenThStuck3()
        {
            bool optimize = false;
            double costTest = this.vArr3[3].Cost;


            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0); // 1. try reflection
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 3);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 4);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 5);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 6);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 7);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 8);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 9);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 10);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 11);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 12);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 13);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 14);
            this.vArr3[4] = Vertix.TryRefluction(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 15);

            ComputeCost3(4);
            if (this.vArr3[4].Cost < costTest) /// Try Expansion
            {
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 0);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 1);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 2);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 3);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 4);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 5);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 6);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 7);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 8);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 9);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 10);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 11);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 12);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 13);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 14);
                this.vArr3[3] = Vertix.TryExpansion(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[3], 15);

                ComputeCost3(3);// find cost0

                if (this.vArr3[3].Cost < this.vArr3[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    optimizeElementsInVertix[4] = "Element: does Expansion"; optimizeElementsInVertix[5] = "Element: does Expansion";
                    optimizeElementsInVertix[6] = "Element: does Expansion"; optimizeElementsInVertix[7] = "Element: does Expansion";
                    optimizeElementsInVertix[8] = "Element: does Expansion"; optimizeElementsInVertix[9] = "Element: does Expansion";
                    optimizeElementsInVertix[10] = "Element: does Expansion"; optimizeElementsInVertix[11] = "Element: does Expansion";
                    optimizeElementsInVertix[12] = "Element: does Expansion"; optimizeElementsInVertix[13] = "Element: does Expansion";
                    optimizeElementsInVertix[14] = "Element: does Expansion"; optimizeElementsInVertix[15] = "Element: does Expansion";

                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                    optimizeElementsInVertix[4] = "Element: does Reflection"; optimizeElementsInVertix[5] = "Element: does Reflection";
                    optimizeElementsInVertix[6] = "Element: does Reflection"; optimizeElementsInVertix[7] = "Element: does Reflection";
                    optimizeElementsInVertix[8] = "Element: does Reflection"; optimizeElementsInVertix[9] = "Element: does Reflection";
                    optimizeElementsInVertix[10] = "Element: does Reflection"; optimizeElementsInVertix[11] = "Element: does Reflection";
                    optimizeElementsInVertix[12] = "Element: does Reflection"; optimizeElementsInVertix[13] = "Element: does Reflection";
                    optimizeElementsInVertix[14] = "Element: does Reflection"; optimizeElementsInVertix[15] = "Element: does Reflection";

                }

            }

            if (this.vArr3[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 3);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 4);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 5);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 6);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 7);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 8);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 9);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 10);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 11);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 12);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 13);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 14);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 15);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 16);
                this.vArr3[4] = Vertix.ContractToC1(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 17);

                ComputeCost3(4);  // contract to c1

                if (costTest < this.vArr3[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 0);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 1);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 2);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 3);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 4);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 5);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 6);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 7);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 8);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 9);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 10);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 11);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 12);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 13);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 14);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 15);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 16);
                    this.vArr3[4] = Vertix.ContractToC2(this.vArr3[0], this.vArr3[1], this.vArr3[2], this.vArr3[4], 17);

                    ComputeCost3(4);// find cost

                    if (this.vArr3[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[4] = "Element: does Contraction toward C2"; optimizeElementsInVertix[5] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[6] = "Element: does Contraction toward C2"; optimizeElementsInVertix[7] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[8] = "Element: does Contraction toward C2"; optimizeElementsInVertix[9] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[10] = "Element: does Contraction toward C2"; optimizeElementsInVertix[11] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[12] = "Element: does Contraction toward C2"; optimizeElementsInVertix[13] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[14] = "Element: does Contraction toward C2"; optimizeElementsInVertix[15] = "Element: does Contraction toward C2";

                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                        optimizeElementsInVertix[4] = "Element: does nothing"; optimizeElementsInVertix[5] = "Element: does nothing";
                        optimizeElementsInVertix[6] = "Element: does nothing"; optimizeElementsInVertix[7] = "Element: does nothing";
                        optimizeElementsInVertix[8] = "Element: does nothing"; optimizeElementsInVertix[9] = "Element: does nothing";
                        optimizeElementsInVertix[10] = "Element: does nothing"; optimizeElementsInVertix[11] = "Element: does nothing";
                        optimizeElementsInVertix[12] = "Element: does nothing"; optimizeElementsInVertix[13] = "Element: does nothing";
                        optimizeElementsInVertix[14] = "Element: does nothing"; optimizeElementsInVertix[15] = "Element: does nothing";

                    }

                }
                else
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; optimizeElementsInVertix[3] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[4] = "Element: does Contraction toward C1"; optimizeElementsInVertix[5] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[6] = "Element: does Contraction toward C1"; optimizeElementsInVertix[7] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[8] = "Element: does Contraction toward C1"; optimizeElementsInVertix[9] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[10] = "Element: does Contraction toward C1"; optimizeElementsInVertix[11] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[12] = "Element: does Contraction toward C1"; optimizeElementsInVertix[13] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[14] = "Element: does Contraction toward C1"; optimizeElementsInVertix[15] = "Element: does Contraction toward C1";

                }
            }

            if (this.vArr3[3].Cost >= costTest)
            {
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 0);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 1);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 2);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 3);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 4);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 5);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 6);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 7);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 8);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 9);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 10);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 11);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 12);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 13);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 14);
                this.VArr3[4] = Vertix.ShrinkGToB(this.vArr3[0], this.vArr3[1], this.vArr3[4], 15);

                ComputeCost3(4);
                if (costTest <= this.vArr3[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 0);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 1);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 2);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 3);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 4);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 5);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 6);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 7);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 8);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 9);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 10);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 11);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 12);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 13);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 14);
                    this.VArr3[4] = Vertix.ShrinkWToB(this.vArr3[2], this.vArr3[0], this.vArr3[4], 15);

                    ComputeCost3(4);
                    if (this.vArr3[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[4] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[5] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[6] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[7] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[8] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[9] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[10] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[11] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[12] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[13] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[14] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[15] = "Element: does Shrink Worse to Best";

                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                        optimizeElementsInVertix[4] = "Element: does nothing"; optimizeElementsInVertix[5] = "Element: does nothing";
                        optimizeElementsInVertix[6] = "Element: does nothing"; optimizeElementsInVertix[7] = "Element: does nothing";
                        optimizeElementsInVertix[8] = "Element: does nothing"; optimizeElementsInVertix[9] = "Element: does nothing";
                        optimizeElementsInVertix[10] = "Element: does nothing"; optimizeElementsInVertix[11] = "Element: does nothing";
                        optimizeElementsInVertix[12] = "Element: does nothing"; optimizeElementsInVertix[13] = "Element: does nothing";
                        optimizeElementsInVertix[14] = "Element: does nothing"; optimizeElementsInVertix[15] = "Element: does nothing";

                    }
                }
                else
                {
                    this.vArr3[3] = (Vertix)this.vArr3[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[4] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[5] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[6] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[7] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[8] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[9] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[10] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[11] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[12] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[13] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[14] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[15] = "Element: does Shrink Good to Best";

                }
            }
            this.vArr3[4].Cost = 0;
            this.vArr3[4].X1 = 1.1; this.vArr3[4].X2 = 0.9; this.vArr3[4].X3 = 1.1; this.vArr3[4].X4 = 0.9; this.vArr3[4].X5 = 1.1; this.vArr3[4].X6 = 0.9; this.vArr3[4].X7 = 1.1;
            this.vArr3[4].X8 = 0.9; this.vArr3[4].X9 = 1.1; this.vArr3[4].X10 = 0.9; this.vArr3[4].X11 = 1.1; this.vArr3[4].X12 = 0.9; this.vArr3[4].X13 = 1.1; this.vArr3[4].X14 = 0.9;
            this.vArr3[4].X15 = 1.1; this.vArr3[4].X16 = 0.9;
            ComputeCost3(4);
            return optimize;
        }

        public bool DoOptimizationWheenThStuck4()
        {
            bool optimize = false;
            double costTest = this.vArr4[3].Cost;


            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0); // 1. try reflection
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 3);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 4);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 5);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 6);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 7);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 8);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 9);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 10);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 11);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 12);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 13);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 14);
            this.vArr4[4] = Vertix.TryRefluction(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 15);

            ComputeCost4(4);
            if (this.vArr4[4].Cost < costTest) /// Try Expansion
            {
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 0);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 1);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 2);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 3);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 4);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 5);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 6);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 7);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 8);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 9);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 10);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 11);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 12);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 13);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 14);
                this.vArr4[3] = Vertix.TryExpansion(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[3], 15);

                ComputeCost4(3);// find cost0

                if (this.vArr4[3].Cost < this.vArr4[4].Cost)  // Expansion is better than Reflection 0 =B
                {
                    optimize = true;
                    optimizeElementsInVertix[0] = "Element: does Expansion"; optimizeElementsInVertix[1] = "Element: does Expansion";
                    optimizeElementsInVertix[2] = "Element: does Expansion"; optimizeElementsInVertix[3] = "Element: does Expansion";
                    optimizeElementsInVertix[4] = "Element: does Expansion"; optimizeElementsInVertix[5] = "Element: does Expansion";
                    optimizeElementsInVertix[6] = "Element: does Expansion"; optimizeElementsInVertix[7] = "Element: does Expansion";
                    optimizeElementsInVertix[8] = "Element: does Expansion"; optimizeElementsInVertix[9] = "Element: does Expansion";
                    optimizeElementsInVertix[10] = "Element: does Expansion"; optimizeElementsInVertix[11] = "Element: does Expansion";
                    optimizeElementsInVertix[12] = "Element: does Expansion"; optimizeElementsInVertix[13] = "Element: does Expansion";
                    optimizeElementsInVertix[14] = "Element: does Expansion"; optimizeElementsInVertix[15] = "Element: does Expansion";

                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();

                }
                else
                {
                    optimize = true;
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimizeElementsInVertix[0] = "Element: does Reflection"; optimizeElementsInVertix[1] = "Element: does Reflection";
                    optimizeElementsInVertix[2] = "Element: does Reflection"; optimizeElementsInVertix[3] = "Element: does Reflection";
                    optimizeElementsInVertix[4] = "Element: does Reflection"; optimizeElementsInVertix[5] = "Element: does Reflection";
                    optimizeElementsInVertix[6] = "Element: does Reflection"; optimizeElementsInVertix[7] = "Element: does Reflection";
                    optimizeElementsInVertix[8] = "Element: does Reflection"; optimizeElementsInVertix[9] = "Element: does Reflection";
                    optimizeElementsInVertix[10] = "Element: does Reflection"; optimizeElementsInVertix[11] = "Element: does Reflection";
                    optimizeElementsInVertix[12] = "Element: does Reflection"; optimizeElementsInVertix[13] = "Element: does Reflection";
                    optimizeElementsInVertix[14] = "Element: does Reflection"; optimizeElementsInVertix[15] = "Element: does Reflection";

                }

            }

            if (this.vArr4[3].Cost >= costTest)  // contract toward either c1 or c2
            {
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 3);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 4);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 5);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 6);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 7);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 8);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 9);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 10);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 11);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 12);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 13);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 14);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 15);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 16);
                this.vArr4[4] = Vertix.ContractToC1(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 17);

                ComputeCost4(4);  // contract to c1

                if (costTest < this.vArr4[4].Cost)   // Check c1
                { // go to c2
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 0);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 1);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 2);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 3);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 4);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 5);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 6);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 7);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 8);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 9);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 10);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 11);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 12);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 13);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 14);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 15);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 16);
                    this.vArr4[4] = Vertix.ContractToC2(this.vArr4[0], this.vArr4[1], this.vArr4[2], this.vArr4[4], 17);

                    ComputeCost4(4);// find cost

                    if (this.vArr4[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Contraction toward C2"; optimizeElementsInVertix[1] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[2] = "Element: does Contraction toward C2"; optimizeElementsInVertix[3] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[4] = "Element: does Contraction toward C2"; optimizeElementsInVertix[5] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[6] = "Element: does Contraction toward C2"; optimizeElementsInVertix[7] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[8] = "Element: does Contraction toward C2"; optimizeElementsInVertix[9] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[10] = "Element: does Contraction toward C2"; optimizeElementsInVertix[11] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[12] = "Element: does Contraction toward C2"; optimizeElementsInVertix[13] = "Element: does Contraction toward C2";
                        optimizeElementsInVertix[14] = "Element: does Contraction toward C2"; optimizeElementsInVertix[15] = "Element: does Contraction toward C2";

                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                        optimizeElementsInVertix[4] = "Element: does nothing"; optimizeElementsInVertix[5] = "Element: does nothing";
                        optimizeElementsInVertix[6] = "Element: does nothing"; optimizeElementsInVertix[7] = "Element: does nothing";
                        optimizeElementsInVertix[8] = "Element: does nothing"; optimizeElementsInVertix[9] = "Element: does nothing";
                        optimizeElementsInVertix[10] = "Element: does nothing"; optimizeElementsInVertix[11] = "Element: does nothing";
                        optimizeElementsInVertix[12] = "Element: does nothing"; optimizeElementsInVertix[13] = "Element: does nothing";
                        optimizeElementsInVertix[14] = "Element: does nothing"; optimizeElementsInVertix[15] = "Element: does nothing";

                    }

                }
                else
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Contraction toward C1"; optimizeElementsInVertix[1] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[2] = "Element: does Contraction toward C1"; optimizeElementsInVertix[3] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[4] = "Element: does Contraction toward C1"; optimizeElementsInVertix[5] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[6] = "Element: does Contraction toward C1"; optimizeElementsInVertix[7] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[8] = "Element: does Contraction toward C1"; optimizeElementsInVertix[9] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[10] = "Element: does Contraction toward C1"; optimizeElementsInVertix[11] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[12] = "Element: does Contraction toward C1"; optimizeElementsInVertix[13] = "Element: does Contraction toward C1";
                    optimizeElementsInVertix[14] = "Element: does Contraction toward C1"; optimizeElementsInVertix[15] = "Element: does Contraction toward C1";

                }
            }

            if (this.vArr4[3].Cost >= costTest)
            {
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 0);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 1);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 2);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 3);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 4);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 5);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 6);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 7);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 8);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 9);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 10);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 11);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 12);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 13);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 14);
                this.VArr4[4] = Vertix.ShrinkGToB(this.vArr4[0], this.vArr4[1], this.vArr4[4], 15);

                ComputeCost4(4);
                if (costTest <= this.vArr4[4].Cost)    // Contract W to B
                {
                    //this.vArr[3] = (Vertix)this.vArr[4].Clone();
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 0);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 1);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 2);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 3);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 4);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 5);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 6);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 7);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 8);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 9);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 10);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 11);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 12);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 13);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 14);
                    this.VArr4[4] = Vertix.ShrinkWToB(this.vArr4[2], this.vArr4[0], this.vArr4[4], 15);

                    ComputeCost4(4);
                    if (this.vArr4[4].Cost < costTest)  // c2 is better than c1
                    {
                        this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                        optimize = true;
                        optimizeElementsInVertix[0] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[2] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[4] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[5] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[6] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[7] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[8] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[9] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[10] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[11] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[12] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[13] = "Element: does Shrink Worse to Best";
                        optimizeElementsInVertix[14] = "Element: does Shrink Worse to Best"; optimizeElementsInVertix[15] = "Element: does Shrink Worse to Best";

                    }
                    else
                    {
                        //this.vArr[3] = (Vertix)this.vArr[4].Clone(); // we cannot improved the situation
                        optimizeElementsInVertix[0] = "Element: does nothing"; optimizeElementsInVertix[1] = "Element: does nothing";
                        optimizeElementsInVertix[2] = "Element: does nothing"; optimizeElementsInVertix[3] = "Element: does nothing";
                        optimizeElementsInVertix[4] = "Element: does nothing"; optimizeElementsInVertix[5] = "Element: does nothing";
                        optimizeElementsInVertix[6] = "Element: does nothing"; optimizeElementsInVertix[7] = "Element: does nothing";
                        optimizeElementsInVertix[8] = "Element: does nothing"; optimizeElementsInVertix[9] = "Element: does nothing";
                        optimizeElementsInVertix[10] = "Element: does nothing"; optimizeElementsInVertix[11] = "Element: does nothing";
                        optimizeElementsInVertix[12] = "Element: does nothing"; optimizeElementsInVertix[13] = "Element: does nothing";
                        optimizeElementsInVertix[14] = "Element: does nothing"; optimizeElementsInVertix[15] = "Element: does nothing";

                    }
                }
                else
                {
                    this.vArr4[3] = (Vertix)this.vArr4[4].Clone();
                    optimize = true;  // C1 is better
                    optimizeElementsInVertix[0] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[1] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[2] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[3] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[4] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[5] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[6] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[7] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[8] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[9] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[10] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[11] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[12] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[13] = "Element: does Shrink Good to Best";
                    optimizeElementsInVertix[14] = "Element: does Shrink Good to Best"; optimizeElementsInVertix[15] = "Element: does Shrink Good to Best";

                }
            }
            this.vArr4[4].Cost = 0;
            this.vArr4[4].X1 = 1; this.vArr4[4].X2 = 1; this.vArr4[4].X3 = 1; this.vArr4[4].X4 = 1; this.vArr4[4].X5 = 1; this.vArr4[4].X6 = 1; this.vArr4[4].X7 = 1;
            this.vArr4[4].X8 = 1; this.vArr4[4].X9 = 1; this.vArr4[4].X10 = 1; this.vArr4[4].X11 = 1; this.vArr4[4].X12 = 1; this.vArr4[4].X13 = 1; this.vArr4[4].X14 = 1;
            this.vArr4[4].X15 = 1; this.vArr4[4].X16 = 1;
            ComputeCost4(4);
            return optimize;
        }
        public object Clone(int i)
        {
            Simplex snew = (Simplex)this.MemberwiseClone();
            snew.vArr[i] = (Vertix)this.vArr[i].Clone();
            return snew;
        }

        public override string ToString()
        {
            return "NofIteration =" + this.z[0].ToString() + "\nX1 " + optimizeElementsInVertix[0] + "\nX2 " + optimizeElementsInVertix[1] + "\nX3 " + optimizeElementsInVertix[2] + 
                "\nX4 " + optimizeElementsInVertix[3] + "\nX5 " + optimizeElementsInVertix[4] + "\nX6 " + optimizeElementsInVertix[5] + "\nX7 " + optimizeElementsInVertix[6] +
                 "\nX8 " + optimizeElementsInVertix[7] + "\nX9 " + optimizeElementsInVertix[8] + "\nX10 " + optimizeElementsInVertix[9] + "\nBest1: " + "a: " + 
                 this.vArr[0].X1.ToString() + "\tb: " + this.vArr[0].X2.ToString() + "\tc: " + this.vArr[0].X3.ToString() + "\td: " + this.vArr[0].X4.ToString() + "\tCost1: " +
                 this.vArr[0].Cost.ToString() + "\nBest2: " + "a: " + this.vArr1[0].X1.ToString() + "\tb: " + this.vArr1[0].X2.ToString() + "\tc: " + this.vArr1[0].X3.ToString() +
                 "\td: " + this.vArr1[0].X4.ToString() + "\tCost2: " + this.vArr1[0].Cost.ToString() + "\tNofIteration =" + this.z[1].ToString() + "\nBest4: " + "a: " + 
                 this.vArr3[0].X1.ToString() + "\tb: " + this.vArr3[0].X2.ToString() + "\tc: " + this.vArr3[0].X3.ToString() + "\td: " + this.vArr3[0].X4.ToString() + "\tCost4: " +
                 this.vArr3[0].Cost.ToString() + "\tNofIteration =" + this.z[3].ToString() + "\nBest5: " + "a: " + this.vArr4[0].X1.ToString() + "\tb: " + this.vArr4[0].X2.ToString() +
                 "\tc: " + this.vArr4[0].X3.ToString() + "\td: " + this.vArr4[0].X4.ToString() + "\tCost5: " + this.vArr4[0].Cost.ToString() + "\tNofIteration =" + this.z[4].ToString(); 
        }
    }
}