﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RosenBrockFunction
{
    public partial class Form1 : Form
    {
        Simplex simp = new Simplex();
        Vertix firstVerOfW = new Vertix();
        Vertix lastVerOfW = new Vertix();

        public Form1()
        {
            InitializeComponent();
        }

        private void cmdNelderMead_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < simp.VArr.Length; i++)
            {
                simp.ComputeCost(i);
                simp.ComputeCost1(i);
                simp.ComputeCost3(i);
                simp.ComputeCost4(i);
            }

            Array.Sort(simp.VArr);
            Array.Sort(simp.VArr1);
            Array.Sort(simp.VArr3);
            Array.Sort(simp.VArr4);
            //MessageBox.Show(simp.ToString());

            DateTime start = DateTime.Now;
            int window1 = 10; int window2 = 10; int window3 = 10; int window4 = 10; int window5 = 10; int iter = 0;
            for (int j = 0; j < int.Parse(txtIterationNumber.Text); j++)
            {
                firstVerOfW = (Vertix)simp.VArr[3].Clone();

                for (int w = 0; w < window1; w++)
                {
                    double whatCostFind = simp.VArr[3].Cost;
                    for (int i = 7; i > -1; i--)                
                    {                    
                        bool didParameterOptimized = simp.DoOptimizationOnVertixElements(i);
                    }

                    if (whatCostFind <= simp.VArr[3].Cost && simp.OptimizeElementsInVertix[0] == "Element: does nothing" && simp.OptimizeElementsInVertix[1] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[2] == "Element: does nothing" && simp.OptimizeElementsInVertix[3] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[4] == "Element: does nothing" && simp.OptimizeElementsInVertix[5] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[6] == "Element: does nothing" && simp.OptimizeElementsInVertix[7] == "Element: does nothing")
                    {
                        bool didParameterOptimized = simp.DoOptimizationWheenThStuck();
                    }
                    iter++;
                    Array.Sort(simp.VArr);
                    if (simp.VArr[0].Cost == 0)
                        break;
                }

                lastVerOfW = (Vertix)simp.VArr[3].Clone();

                double m1 = lastVerOfW.A - firstVerOfW.A; double m2 = lastVerOfW.B - firstVerOfW.B; double m3 = lastVerOfW.C - firstVerOfW.C; double m4 = lastVerOfW.D - firstVerOfW.D;
                double m5 = lastVerOfW.E - firstVerOfW.E; double m6 = lastVerOfW.F - firstVerOfW.F; double m7 = lastVerOfW.G - firstVerOfW.G; double m8 = lastVerOfW.H - firstVerOfW.H;
               
                if (m1 == 0 && m2 == 0 && m3 == 0 && m4 == 0 && m5 == 0 && m6 == 0 && m7 == 0 && m8 == 0)
                    window1 = 0;
                /////// Simplex 2

                firstVerOfW = (Vertix)simp.VArr1[3].Clone();

                for (int w = 0; w < window2; w++)
                {
                    double whatCostFind = simp.VArr1[3].Cost;
                    for (int i = 7; i > -1; i--)
                    {
                        bool didParameterOptimized = simp.DoOptimizationOnVertixElements1(i);
                    }

                    if (whatCostFind <= simp.VArr1[3].Cost && simp.OptimizeElementsInVertix[0] == "Element: does nothing" && simp.OptimizeElementsInVertix[1] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[2] == "Element: does nothing" && simp.OptimizeElementsInVertix[3] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[4] == "Element: does nothing" && simp.OptimizeElementsInVertix[5] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[6] == "Element: does nothing" && simp.OptimizeElementsInVertix[7] == "Element: does nothing")
                    {
                        bool didParameterOptimized = simp.DoOptimizationWheenThStuck1();
                    }
                    Array.Sort(simp.VArr1);

                    if (simp.VArr1[0].Cost == 0)
                        break;
                }

                lastVerOfW = (Vertix)simp.VArr1[3].Clone();

                m1 = lastVerOfW.A - firstVerOfW.A; m2 = lastVerOfW.B - firstVerOfW.B; m3 = lastVerOfW.C - firstVerOfW.C; m4 = lastVerOfW.D - firstVerOfW.D;
                m5 = lastVerOfW.E - firstVerOfW.E; m6 = lastVerOfW.F - firstVerOfW.F; m7 = lastVerOfW.G - firstVerOfW.G; m8 = lastVerOfW.H - firstVerOfW.H;
                if (m1 == 0 && m2 == 0 && m3 == 0 && m4 == 0 && m5 == 0 && m6 == 0 && m7 == 0 && m8 == 0)
                    window2 = 0;
                /////// Simplex 4

                firstVerOfW = (Vertix)simp.VArr3[3].Clone();

                for (int w = 0; w < window4; w++)
                {
                    double whatCostFind = simp.VArr3[3].Cost;
                    for (int i = 7; i > -1; i--)
                    {
                        bool didParameterOptimized = simp.DoOptimizationOnVertixElements3(i);
                        //whatCostFind = simp.VArr[3].Cost;                    
                    }

                    if (whatCostFind <= simp.VArr3[3].Cost && simp.OptimizeElementsInVertix[0] == "Element: does nothing" && simp.OptimizeElementsInVertix[1] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[2] == "Element: does nothing" && simp.OptimizeElementsInVertix[3] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[4] == "Element: does nothing" && simp.OptimizeElementsInVertix[5] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[6] == "Element: does nothing" && simp.OptimizeElementsInVertix[7] == "Element: does nothing")
                    {
                        bool didParameterOptimized = simp.DoOptimizationWheenThStuck3();
                    }
                    Array.Sort(simp.VArr3);

                    if (simp.VArr3[0].Cost == 0)
                        break;
                }

                lastVerOfW = (Vertix)simp.VArr3[3].Clone();

                m1 = lastVerOfW.A - firstVerOfW.A; m2 = lastVerOfW.B - firstVerOfW.B; m3 = lastVerOfW.C - firstVerOfW.C; m4 = lastVerOfW.D - firstVerOfW.D;
                m5 = lastVerOfW.E - firstVerOfW.E; m6 = lastVerOfW.F - firstVerOfW.F; m7 = lastVerOfW.G - firstVerOfW.G; m8 = lastVerOfW.H - firstVerOfW.H;
                if (m1 == 0 && m2 == 0 && m3 == 0 && m4 == 0 && m5 == 0 && m6 == 0 && m7 == 0 && m8 == 0)
                    window4 = 0;
                /////// Simplex 5

                firstVerOfW = (Vertix)simp.VArr4[3].Clone();

                for (int w = 0; w < window5; w++)
                {
                    double whatCostFind = simp.VArr4[3].Cost;
                    for (int i = 0; i < 8; i++)
                    {
                        bool didParameterOptimized = simp.DoOptimizationOnVertixElements4(i);
                    }

                    if (whatCostFind <= simp.VArr4[3].Cost && simp.OptimizeElementsInVertix[0] == "Element: does nothing" && simp.OptimizeElementsInVertix[1] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[2] == "Element: does nothing" && simp.OptimizeElementsInVertix[3] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[4] == "Element: does nothing" && simp.OptimizeElementsInVertix[5] == "Element: does nothing"
                        && simp.OptimizeElementsInVertix[6] == "Element: does nothing" && simp.OptimizeElementsInVertix[7] == "Element: does nothing")
                    {
                        bool didParameterOptimized = simp.DoOptimizationWheenThStuck4();
                    }
                    Array.Sort(simp.VArr4);

                    if (simp.VArr4[0].Cost == 0)
                        break;
                }

                lastVerOfW = (Vertix)simp.VArr4[3].Clone();

                m1 = lastVerOfW.A - firstVerOfW.A; m2 = lastVerOfW.B - firstVerOfW.B; m3 = lastVerOfW.C - firstVerOfW.C; m4 = lastVerOfW.D - firstVerOfW.D;
                m5 = lastVerOfW.E - firstVerOfW.E; m6 = lastVerOfW.F - firstVerOfW.F; m7 = lastVerOfW.G - firstVerOfW.G; m8 = lastVerOfW.H - firstVerOfW.H;
                if (m1 == 0 && m2 == 0 && m3 == 0 && m4 == 0 && m5 == 0 && m6 == 0 && m7 == 0 && m8 == 0)
                    window5 = 0;

                if (window1 == 0 && window2 == 0 && window4 == 0 && window5 == 0)
                    break;

                if (simp.VArr[0].Cost == 0 || simp.VArr1[0].Cost == 0 || simp.VArr3[0].Cost == 0 || simp.VArr4[0].Cost == 0)
                    break;
            }
            TimeSpan timeItTook = DateTime.Now - start;
            MessageBox.Show(simp.ToString());
            MessageBox.Show(timeItTook.ToString());
            MessageBox.Show("Number of simplexes = " + iter.ToString());
        }
    }
}
